<?php

$get_started_url = EASY_TRANSLATION_MANAGER_URL.'images/getstarted/';

echo '<div class="wrap etm-about-wrap">';
echo 	'<h1>'.__( 'Welcome to Easy Translation Manager','etm').'</h1>';

echo 	'<div class="etm-about-text">'.__( 'Thank you for installing this plugin! Using Easy Translation Manager will make it easy for you to manage a multi language WordPress powered website.' ).'</div>';

echo 	'<div class="wp-etm-badge"></div>';

echo 	'<div class="changelog">';
echo    	'<h3>'. __( 'Easier Translation Management' ).'</h3>';

echo 		'<div class="feature-section images-stagger-right">';
echo			'<div class="feature-images">';
echo				'<img src="'.$get_started_url.'activate_languages.png" width="265" class="angled-right" />';
echo				'<img src="'.$get_started_url.'design_and_layout.png" width="265" class="angled-left" />';
echo 			'</div>';
 
echo			'<div class="left-feature">';
echo				'<h4>'.__( 'Get Started in 3 Easy Steps!' ).'</h4>';
echo				'<p>'.__( 'WordPress has been translated into more than 70 languages and many Theme and Plugin developers have already localized their Themes and Plugins. However managing a multi-language WordPress website can often be a quite complicated task.' ).'</p>';
echo				'<p>'.__( 'We often see that parts og Plugins or Themes have not been translated or a specific plugin is not available in the language you need. We have simplified things, when it comes to translating your content as well as Plugins and Themes.' ).'</p>';
echo				'<p>'._e( 'Follow these 3 Easy Steps to Get Started.' ).'</p>';

echo				'<ol>';
echo					'<li>'.__( 'Select the <a href="/wp-admin/admin.php?page=etm-opt">Options</a> menu and under General Settings you activate the languages you want to translate your website into.' ).'</li>';
echo					'<li>'.__( 'Select the Design and Layout in the <a href="/wp-admin/admin.php?page=etm-opt">Options</a> menu and choose how you want your visitors to be able to select their preferred language.' ).'</li>';
echo					'<li>'.__( 'Start the translating process by choosing either <a href="/wp-admin/admin.php?page=ect_plugins_translations">Plugin Translation</a>, <a href="/wp-admin/admin.php?page=ect_themes_translations">Theme Translation</a>, <a href="/wp-admin/admin.php?page=ect_page_translations">Page Translation</a>, <a href="/wp-admin/admin.php?page=ect_post_translations">Post Translation</a> or <a href="/wp-admin/admin.php?page=ect_menu_translations">Menu Translation</a>.' ).'</li>';
echo				'</ol>';			
			
echo				'<div class="feature-images">';
echo					'<img src="'.$get_started_url.'select_languages.png" width="265" class="angled-right" />';
echo				'</div>';

echo				'<h4>'.__( 'Insert Widget or Tag to show language selection' ).'</h4>';
echo				'<p>' .__( 'It is really easy for your visitors to choose their preferred language when they visit your website. You can choose between inserting a Widget in your sidebar to let visitors choose the language or you can insert a tag directly into your template.').'</p>';
echo				'<p>'.__('It is also possible to set the language based on the language of the visitors Internet browser.' ).'</p>';
echo			'</div>';
echo		'</div>';
echo	'</div>';

echo	'<div class="changelog">';
echo		'<h3>'.__( 'Some of the features' ).'</h3>';

echo		'<div class="feature-section text-features">';
echo			'<h4>'.__( 'Test language on IP' ).'</h4>';
echo			'<p>'. __( 'In the Options Panel under General Settings you can enter one or more IP addresses, which will be able to view the translations. Under Languages you can then set which languages this is applicable for. This is a helpful feature if you wish to test a specific language translation before releasing it.' ).'</p>';
echo		'<div>';

echo			'<h4>'.__( 'Manage availability of Items'  ).'</h4>';
echo			'<p>'.__( 'You can easily choose which Plugins, Themes, Pages, Posts, Custom Post Types and Menus that will be made available for translation.').'</p>';
echo		'</div>';
echo 	'</div>';
echo	'<div class="feature-section screenshot-features">';
echo		'<div class="angled-left">';
echo			'<img src="'.$get_started_url.'set_ip_address_for_language_test.png" />';
echo			'<h4>'. __( 'Support for Custom Capabilities' ).'</h4>';
echo			'<p>' .__( 'We have added 13 Custom Capabilities to the plugin, which makes it really easy for you to specify exactly what your different user roles have access to.' ).'</p>';
echo		'</div>';
echo		'<div class="angled-right">';
echo			'<img src="'.$get_started_url.'hide_plugins.png" />';
echo			'<h4>'.__( 'Plugin & Theme Translation' ).'</h4>';
echo			'<p>'. __( 'Easy Translation Manager automatically scans your plugins and themes folder in order to find strings (textdomains) ready for translation. If you see any rows marked with red this indicates that the text does not have a text domain, and will require manual action in order to be ready for translation. If you have other strings that need translation you can also add them manually.' ).'</p>';
echo		'</div>';
echo	'</div>';
echo '</div>';




echo '<div class="changelog">';
echo 	'<h3>Support for SEO in multiple languages</h3>';

echo 	'<div class="feature-section three-col">';
echo 		'<div>';
echo 			'<h4>WordPress SEO by Yoast</h4>';
echo 			'<p>Instead of building our own SEO system from scratch for Easy Translation Manager we decided to support <a href="http://yoast.com/wordpress/seo/">WordPress SEO by Yoast</a>. This is the most complete WordPress SEO plugin that exists today for WordPress.org  users. It incorporates everything from a snippet preview and page analysis functionality that helps you optimize your pages content, images titles, meta descriptions and more to XML sitemaps, and loads of optimization options in between.</p>';
echo 		'</div>';
echo 		'<div>';
echo 			'<h4>How does it work?</h4>';
echo 			'<p>You need to install <a href="http://yoast.com/wordpress/seo/">WordPress SEO by Yoast</a> and then activate support for this plugin in the <a href=/wp-admin/admin.php?page=etm-opt>Options Panel</a>. After installing the WordPress SEO plugin and activating support for this you will get a SEO button in each translation window. When you click this you will be able to add SEO information for each translation.</p>';
echo 		'</div>';
echo 		'<div class="last-feature">';
echo 			'<h4>What is supported?</h4>';
echo 			'<p>You can add SEO specific information for all Posts and Pages like: <em>Focus Keywords, SEO Title and Meta Description</em>. Easy Translation Manager will also automatically include all the language specific links in the sitemaps generated by the WordPress SEO. This will make optimization for each language much easier!</p>';
echo 		'</div>';
echo 	'</div>';
echo '</div>';






echo '<div class="return-to-dashboard">';

if ( current_user_can( 'update_core' ) && isset( $_GET['updated'] ) ){
	echo '<a href="'.esc_url( network_admin_url( 'update-core.php' ) ).'">';
		echo (is_multisite() ? _e( 'Return to Updates' ) : _e( 'Return to Dashboard &rarr; Updates' ));
	echo '</a> |';


}
	echo '<a href="<?php echo esc_url( admin_url() ); ?>">'._e( 'Go to Dashboard &rarr; Home' ).'</a>';
	echo '</div>';     
echo '</div>';   
 
?>