<?php

class etm_options {
	var $screen_title = 'Options';
	var $screen_menu = 'Options';    
	var $plugin_id;
	var $tdom = 'etm';
	
	function etm_options($parent_id){
		$this->plugin_id = $parent_id.'-opt';
		
		//add_submenu_page($parent_id,$this->screen_menu,$this->screen_menu,0,$this->plugin_id,array(&$this,'test'));
		add_filter("pop_admin_head_{$this->plugin_id}",array(&$this,'create_header'),10,1);
		add_filter("pop-options_{$this->plugin_id}",array(&$this,'options'),10,1);

        remove_all_actions('wp_ajax_pop_uploader-'.$this->plugin_id);
        add_action('wp_ajax_pop_uploader-'.$this->plugin_id, array(&$this,'etm_pop_uploader'));					
	} 

	function etm_pop_uploader(){
        require_once(EASY_TRANSLATION_MANAGER_PATH.'inc/fileupload.php');
		$allowedExtensions = array();
		$sizeLimit = 10 * 1024 * 1024;
		$uploader = new etm_qqFileUploader($allowedExtensions, $sizeLimit);
		$result = $uploader->handleUpload();
		echo htmlspecialchars(json_encode($result), ENT_NOQUOTES);		
		die();
	}
        
	function options($t){
        global $wpdb,$wpseo_sitemaps,$wpseo_front;
        
        $unified_css_style = 'width:200px;float: right;margin-right: 10px;';
        
		$i = count($t);
		//-------------------------	Generelle Settings	
		$i++;
		$t[$i] = (object)array();
		$t[$i] = (object)array();
		$t[$i]->id 			= 'Generalte-settings'; 
		$t[$i]->label 		= __('General Settings','etm');//title on tab
		$t[$i]->right_label	= __('Input data','etm');//title on tab
		$t[$i]->page_title	= __('General Settings','etm');//title on content
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
		
				
		$temp = array();
		$temp[] = (object)array(
				'id'	=> 'GP_name',
				'type'	=> 'text',
				'label'	=> __('Get / post tags','etm'),
				'description' => __('For multible GET/POST tag then seperate by | eg. lang|la|Language <br />','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);
		$temp[] = (object)array(
				'id'	=> 'test_ip',
				'type'	=> 'text',
				'label'	=> __('Language test IP','etm'),
				'description' => __('For multiple IP addresses seperate by | eg. 192.168.2.1|192.168.2.2. <br />','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
			
		$temp[] = (object)array(
				'id'	=> 'rtl_front_page_css',
				'type'	=> 'text',
				'label'	=> __('RTL frontpage css','etm'),
				'default' => 'rtl.css',
				'description' => __('ONLY CHANGE THIS IF YOUR RTL.CSS IS LOCATED IN A SUB FOLDER OR HAS A DIFFERENT NAME. This allow you to change the location of the rtl.css file in your theme folder.','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);
			
		$temp[] = (object)array(
				'id'		=> 'browser_languash',
				'label'		=> __('Browser language','etm'),
				'type'		=> 'yesno',
				'description'=>  sprintf(__('Choose %s to set the translation language to the browser default language','etm'),__('Yes','etm')),
				'el_properties'	=> array(),
				'save_option'=>true,
				'load_option'=>true
		);	
		
		$temp[] = (object)array(
				'id'		=> 'deactivate_seach',
				'label'		=> __('Deactivate Search','etm'),
				'type'		=> 'yesno',
				'default' 	=> false, 
				'description'=>  __('Select Yes to disable the language specific search feature.','etm'),
				'el_properties'	=> array(),
				'save_option'=>true,
				'load_option'=>true
		);		

		$temp[] = (object)array(
				'id'		=> 'fade_none_translation_menu',
				'label'		=> __('Active or Inactive flags','etm'),
				'type'		=> 'yesno',
				'description'=> __('If you have content that is not translated into all activated languages, you can choose to show a "inactive" flag if a page, post is not available in a specific language.','etm'),
                'save_option'=>true,
				'load_option'=>true
		);	 
        
		$temp[] = (object)array(
				'id'		=> 'use_permalink',
				'label'		=> __('Use Permalink','etm'),
				'type'		=> 'yesno',
				'description'=>  __('Use the custom language permalink','etm'),
				'el_properties'	=> array(),
				'save_option'=>true,
				'load_option'=>true
		);
      
		$temp[] = (object)array(
				'id'		=> 'change_wp_admin',
				'label'		=> __('Change wp-admin Language','etm'),
				'type'		=> 'yesno',
				'description'=>  sprintf(__('This feature changes the default language if the .mo file(s) are installed. At the moment the .mo file(s) has to be install manually.<br><br> 1. Download the .mo file(s)','etm') . ' <a target="_black" href="http://codex.wordpress.org/WordPress_in_Your_Language">'.__('here','etm').'</a><br>2. Upload the .mo file(s) to the /wp-content/languages/ folder (Create the folder if needed)',__('Yes','etm')),
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.change_wp_admin\');'),
                'hidegroup'	=> '#hide_change_wp_admin_group',
                'save_option'=>true,
				'load_option'=>true
		);	
		
		$temp[] = (object)array(
				'id'	=> 'hide_change_wp_admin_group',
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
		);

        $temp[] = (object)array(
				'id'	=> 'upload_files',
				'type'	=>'fileuploader',
				'label'	=> __('Upload files','etm'),
				'description'=> __('Upload all your language files to the /wp-content/languages/ folder.','etm'),
				'save_option'=>false,
				'load_option'=>false
		);
        
		$temp[] = (object)array(
		  'id'=>'hide_change_wp_admin_group',
				'type'=>'div_end'
		);

        $temp_retrive_array_sort = etm_tools_subval_sort( etm_languages_flags() ,'english_name','desc');
		
		$temp_array_default = array();
		$main_array_default = array();
		$secoundary_array_default = array();
			
		foreach($temp_retrive_array_sort as $tmp_flag){
			$temp_array_default[$tmp_flag['code']] = $tmp_flag['org_name'].' ('.$tmp_flag['english_name'].')';
		
			if($tmp_flag['primary_order'] == 1){
				$main_array_default[] = $tmp_flag;
			} else {
				$secoundary_array_default[] = $tmp_flag;
			}
		
		}		
			

		$temp[] = (object)array(
				'id'	=> 'default_language',
				'type'	=> 'select',
				'label'	=> __('Default Language','etm'),
				'options'=> $temp_array_default,
				'description'=>__('Select default Language frontend','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);		
            
		$temp[] = (object)array(
				'id'	=> 'default_language_wp_etm',
				'type'	=> 'select',
				'label'	=> __('Default Language wp-admin','etm'),
				'options'=> $temp_array_default,
				'description'=>__('Select default Language','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
            
            
		$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Hide Elements when not translated','etm'),
			'description'=>__('The plugin will display the default language if a element is not translated, but you can choose to hide elements not translated by checking one or multiple.','etm')	
		);
        
		$temp[] =(object)array(
				'id'		=> 'hide_elements_pages',
				'label'		=> __('Pages','etm'),
				'type'		=> 'checkbox',
				'save_option'=>true,
				'load_option'=>true
				);
            
		$temp[] =(object)array(
				'id'		=> 'hide_elements_posts',
				'label'		=> __('Posts','etm'),
				'type'		=> 'checkbox',
				'save_option'=>true,
				'load_option'=>true
				);
                
		$temp[] =(object)array(
				'id'		=> 'hide_elements_tags',
				'label'		=> __('Tags','etm'),
				'type'		=> 'checkbox',
				'save_option'=>true,
				'load_option'=>true
				);

		$temp[] =(object)array(
				'id'		=> 'hide_elements_categories',
				'label'		=> __('Categories','etm'),
				'type'		=> 'checkbox',
				'save_option'=>true,
				'load_option'=>true
				);          
            
		$temp[] =(object)array(
				'id'		=> 'hide_elements_menus',
				'label'		=> __('Menus','etm'),
				'type'		=> 'checkbox',
				'save_option'=>true,
				'load_option'=>true
				);      
                       
		$temp[] =(object)array(
				'id'		=> 'hide_elements_default',
				'label'		=> __('Default language','etm'),
				'type'		=> 'checkbox',
				'save_option'=>true,
				'load_option'=>true
				);
            
            
		$temp[] = (object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','etm'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);
            

		
		$t[$i]->options = $temp;
		
		
	
		//------------------------- Manage view -------------------
		
		$i++;
		$t[$i] = (object)array();
		$t[$i]->id 			= 'manage-view-listing'; 
		$t[$i]->label 		= __('Manage availability of Items','etm');//title on tab
		$t[$i]->right_label	= __('Select available items for translation','etm');//title on tab
		$t[$i]->page_title	= __('Select available items for translation','etm');//title on content
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
		$temp = '';
		
		$temp[] = (object)array(
			'id'=>'hide_auther',
			'label'=> __('Hide author','etm'),
			'type'=>'checkbox',
			'description'=>__('Removes all author names in the tables','etm'),
			'save_option'=>true,
			'load_option'=>true
		);
		
		
		//------- Plugins -----		
		
		$plugins = get_plugins();
		$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Hide Plugin','etm'),
			'description'=>__('As default all items will be available for translation. If you switch the status to "Yes" and tick off a check box the item will be unavailable for translation.','etm')	
		);
			
		$temp[] =(object)array(
				'id'		=> 'hide_plugins',
				'label'		=> __('Plugin','etm'),
				'type'		=> 'yesno',
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.hide_plugins\');'),
				'hidegroup'	=> '#hide_plugins_group',
				'save_option'=>true,
				'load_option'=>true
				);
		
		$temp[] = (object)array(
				'id'	=> 'hide_plugins_group',
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
		);
		
		$temp[] = (object)array(
				'id'=>'hide_plugins_all',
				'label'=> '<b>Hide all plugins</b>',
				'type'=>'checkbox',
				'el_properties'=>array('class'=>'hide_all'),
				'save_option'=>true,
				'load_option'=>true
		);		
		
		foreach($plugins as $key => $plugin){
			$key_array = explode('/',$key);
			
			$temp[] = (object)array(
					'id'=>'hide_plugins_'.urlencode($key_array[0]),
					'label'=> $plugin['Name'],
					'type'=>'checkbox',
					'save_option'=>true,
					'load_option'=>true
			);
		}
		
		$temp[] = (object)array(
			'id'=>'hide_plugins_group',
			'type'=>'div_end'
		);	
		//------- themes -----

		$wp_version_is_3_3 = etm_tools_version_check();

		if($wp_version_is_3_3){
			$themes = wp_get_themes();	
		} else {
			$themes = get_themes();	
		}

		
		
		$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Hide Theme','etm')	
		);		
		
		$temp[] =(object)array(
				'id'		=> 'hide_theme',
				'label'		=> __('Theme','etm'),
				'type'		=> 'yesno',
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.hide_theme\');'),
				'hidegroup'	=> '#hide_themes_group',
				'save_option'=>true,
				'load_option'=>true
		);
		
		$temp[] = (object)array(
				'id'	=> 'hide_themes_group',
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
		);
		
		$temp[] = (object)array(
				'id'=>'hide_themes_all',
				'label'=> '<b>Hide all themes</b>',
				'type'=>'checkbox',
				'el_properties'=>array('class'=>'hide_all'),
				'save_option'=>true,
				'load_option'=>true
		);
		
		foreach($themes as $key => $theme){
			$key_array = explode('/',$key);
			
			$temp[] = (object)array(
				'id'		=> 'hide_themes_'.urlencode($key_array[0]),
				'label'		=> $theme['Name'],
				'type'		=> 'checkbox',
				'save_option'=>true,
				'load_option'=>true
			);	
		}

		$temp[] = (object)array(
			'id'=>'hide_themes_group',
			'type'=>'div_end'
		);
		
		// ----- pages ----
	
		$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Hide Page','etm')	
		);		
		
		$array_pages = array('publish','pending','draft','private','attachment','inherit');
		foreach($array_pages as $array_page){
		
			$temp[] =(object)array(
				'id'		=> 'hide_pages_'.urlencode($array_page),
				'label'		=> 'Status '.$array_page,
				'type'		=> 'yesno',
				'save_option'=>true,
				'load_option'=>true
			);
		
			/*
			
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.hide_page_'.urlencode($array_page).'\');'),
				'hidegroup'	=> '#hide_pages_group_'.urlencode($array_page),
			
			$temp[] = (object)array(
				'id'	=> 'hide_pages_group_'.urlencode($array_page),
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
			);
		
			$temp[] = (object)array(
							'id'=>'hide_page_'.$array_page.'_all',
							'label'=> '<b>Hide all '.$array_page.'</b>',
							'type'=>'checkbox',
							'el_properties'=>array('class'=>'hide_all'),
							'save_option'=>true,
							'load_option'=>true
			);
		
			$args = array('posts_per_page' => -1,   'post_type'=>'page','post_status' => $array_page );
    		$tmp_data_array = array();
			$page_types=query_posts($args); 		
		
			foreach($page_types as $page_type){
			
				$temp[] = (object)array(
					'id'		=> 'hide_page_'.$array_page.'_'.$page_type->ID,
					'label'		=> $page_type->post_title,
					'type'		=> 'checkbox',
					'save_option'=>true,
					'load_option'=>true
				);	
			}

			$temp[] = (object)array(
				'id'=>'hide_pages_group_'.urlencode($array_page),
				'type'=>'div_end'
			);
			
			*/
		}

		// ------- post status -------
		
		

		$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Hide Post Status','etm')	
		);	
			
		$array_pages = array('publish','pending','draft','private','attachment','inherit');	
		foreach($array_pages as $array_page){
			$temp[] =(object)array(
				'id'		=> 'hide_posts_status_'.$array_page,
				'label'		=> __('Status','etm').' '.$array_page,
				'type'		=> 'yesno',
				'save_option'=>true,
				'load_option'=>true
			);
			
			/*
			
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.hide_posts_status_'.$array_page.'\');'),
				'hidegroup'	=> '#hide_posts_status_groups_'.$array_page,
		
			$temp[] = (object)array(
				'id'	=> 'hide_posts_status_groups_'.$array_page,
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
			);

			
			$args = array('posts_per_page' => 9999999999, 'post_status' => $array_page);
			$posts_array= query_posts($args);			
			
			$temp[] = (object)array(
						'id'=>'hide_post_status_'.$array_page.'_all',
						'label'=> '<b>Hide all '.$array_page.'</b>',
						'type'=>'checkbox',
						'el_properties'=>array('class'=>'hide_all'),
						'save_option'=>true,
						'load_option'=>true
			);
				

			foreach($posts_array as $post){
				if($array_page != 'page' && $array_page != 'nav_menu_item' ){
					$temp[] = (object)array(
						'id'=>'hide_post_status_'.$array_page.'_'.$post->ID,
						'label'=> $post->post_title,
						'type'=>'checkbox',
						'save_option'=>true,
						'load_option'=>true
					);
				}
			}
		
			$temp[] = (object)array(
				'id'=>'hide_posts_status_groups_'.$array_page,
					'type'=>'div_end'
			);
			
			*/
			
		}
			
			
		//----- hide post types
		
				$post_types = get_post_types();
		$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Hide Post Types','etm')	
		);	
			
			
		foreach($post_types as $post_type){
			if($post_type != 'page' && $post_type != 'nav_menu_item' && $post_type != 'revision'){
				$temp[] =(object)array(
					'id'		=> 'hide_posts_types_'.$post_type,
					'label'		=> __('Type','etm').' '.$post_type,
					'type'		=> 'yesno',
					'save_option'=>true,
					'load_option'=>true
				);
				
				
				/*
				
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.hide_posts_types_'.$post_type.'\');'),
				'hidegroup'	=> '#hide_posts_types_groups_'.$post_type,
		
				$temp[] = (object)array(
					'id'	=> 'hide_posts_types_groups_'.$post_type,
					'el_properties'=>array('class'=>'hide_group'),
					'type'=>'div_start'
				);

			
				$args = array('posts_per_page' => 9999999999, 'post_status' => array('publish','pending','draft','private','static','object','attachment','inherit','future') ,  'post_type'=>$post_type);
				$posts_array= query_posts($args);			
			
				$temp[] = (object)array(
							'id'=>'hide_posts_types_'.$post_type.'_all',
							'label'=> '<b>Hide all '.$post_type.'</b>',
							'type'=>'checkbox',
							'el_properties'=>array('class'=>'hide_all'),
							'save_option'=>true,
							'load_option'=>true
				);
				

				foreach($posts_array as $post){
			
					$temp[] = (object)array(
							'id'=>'hide_posts_types_'.$post_type.'_'.$post->ID,
							'label'=> $post->post_title,
							'type'=>'checkbox',
							'save_option'=>true,
							'load_option'=>true
					);
				}
		
				$temp[] = (object)array(
				'id'=>'hide_posts_types_groups_'.$post_type,
					'type'=>'div_end'
				);
				
				*/
			
			}
		}	
			
			
	
			
			
		//---- Menu	
		


		$menu_names = wp_get_nav_menus();
		$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Hide Menu','etm')	
		);	
			
		$temp[] =(object)array(
				'id'		=> 'hide_menus',
				'label'		=> __('Menu','etm'),
				'type'		=> 'yesno',
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.hide_menus\');'),
				'hidegroup'	=> '#hide_menu_group',
				'save_option'=>true,
				'load_option'=>true
				);
			
		
		$temp[] = (object)array(
				'id'	=> 'hide_menu_group',
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
		);
		
		$temp[] = (object)array(
				'id'=>'hide_menu_all',
				'label'=> '<b>Hide all menus</b>',
				'type'=>'checkbox',
				'el_properties'=>array('class'=>'hide_all'),
				'save_option'=>true,
				'load_option'=>true
		);		
		
		foreach($menu_names as $menu_name){
			
			$temp[] = (object)array(
					'id'=>'hide_menu_'.$menu_name->term_id,
					'label'=> $menu_name->name,
					'type'=>'checkbox',
					'save_option'=>true,
					'load_option'=>true
			);
		}
		
		$temp[] = (object)array(
			'id'=>'hide_menu_group',
			'type'=>'div_end'
		);		

		$temp[] = (object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','etm'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);

		$t[$i]->options = $temp;
		
		//-------------------------	Listing Settings		
		$i++;
		$t[$i] = (object)array();
		$t[$i]->id 			= 'controle-listing'; 
		$t[$i]->label 		= __('List Configuration','etm');//title on tab
		$t[$i]->right_label	= __('Set defaults for listings','etm');//title on tab
		$t[$i]->page_title	= __('List Configuration','etm');//title on content
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
		
		$temp = array();
		$temp[] = (object)array(
				'id'	=> 'limit_interval',
				'type'	=> 'select',
				'label'	=> __('Number of objects shown per page : ','etm'),
				'options'=> array(
					'10'=>'10',
					'15'=>'15',
					'25'=>'25',
					'50'=>'50',
					'100'=>'100'
				),
				'description'=>__('Number of object shown pr page','etm'),
				'el_properties'=>array('class'=>'dropdown1','style'=>'width:130px'),
				'default'=>'2',
				'save_option'=>true,
				'load_option'=>true
			);
			
			
			$getmenudatas = etm_tools_get_types();
			$count = 0;
			
			foreach($getmenudatas as $getmenudata){ 
				$temp[] = (object)array(
					'id'	=> 'namesortlist'.$count,
					'type'	=> 'subtitle',
					'label'	=> __($getmenudata['name'],'etm')
				);
				
				$etm_columns = array();
				$etm_columns_tmp = array();
				$etm_columns = $getmenudata['etm_columns_group'];

				
				foreach($etm_columns as $etm_column){
					if($etm_column['sorteble'] == 'true'){
						$etm_columns_tmp[$etm_column['backtitle']] = $etm_column['title'];
					}
				}
		
				if(!empty($etm_columns_tmp) && count($etm_columns_tmp)>0){
					$temp[] = (object)array(
						'id'	=> 'sort_group_list_'.$getmenudata['tag'],
						'type'	=> 'select',
						'label'	=> __('First table sort by : ','etm'),
						'options'=> $etm_columns_tmp,
						'el_properties'=>array('class'=>'dropdown1','style'=>'width:130px'),
						'default'=>'2',
						'save_option'=>true,
						'load_option'=>true
					);
		
					$temp[] = (object)array(
						'id'	=> 'sort_group_list_direction_'.$getmenudata['tag'],
						'type'	=> 'select',
						'label'	=> __('First table direction : ','etm'),
						'options'=> array(
							'decs'=>'Descending (A..Z)',
							'asc'=>'Ascending (Z...A)'
						),
						'el_properties'=>array('class'=>'dropdown1','style'=>'width:130px'),
						'default'=>'2',
						'save_option'=>true,
						'load_option'=>true
					);
				}
				
				
				
				$etm_columns = array();
				$etm_columns_tmp = array();
				if(!empty($getmenudata['etm_columns_single'])){
					$etm_columns = $getmenudata['etm_columns_single'];
				}
				

				if(!empty($etm_columns) && count($etm_columns)>0){
					foreach($etm_columns as $etm_column){
						if($etm_column['sorteble'] == 'true'){
							$etm_columns_tmp[$etm_column['backtitle']] = $etm_column['title'];
						}
					}
				}
				if(!empty($etm_columns_tmp) && count($etm_columns_tmp)>0){
					$temp[] = (object)array(
						'id'	=> 'sort_single_list_'.$getmenudata['tag'],
						'type'	=> 'select',
						'label'	=> __('Second table sort by : ','etm'),
						'options'=> $etm_columns_tmp,
						'el_properties'=>array('class'=>'dropdown2','style'=>'width:130px'),
						'default'=>'2',
						'save_option'=>true,
						'load_option'=>true
					);
		
					$temp[] = (object)array(
						'id'	=> 'sort_single_list_direction_'.$getmenudata['tag'],
						'type'	=> 'select',
						'label'	=> __('Second table direction : ','etm'),
						'options'=> array(
							'decs'=>'Descending (A..Z)',
							'asc'=>'Ascending (Z...A)'
						),
						'el_properties'=>array('class'=>'dropdown1','style'=>'width:130px'),
						'default'=>'2',
						'save_option'=>true,
						'load_option'=>true
					);
				}
				$count++;
			}		
				
			$temp[] = (object)array(
				'type'	=> 'clear',
			);	
			
			$temp[] = (object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','etm'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);
			
						
			
		$t[$i]->options = $temp;
		
		
		//--------------- show desing
		
		$i++;
		$t[$i] = (object)array();
		$t[$i]->id 			= 'select-design-listing'; 
		$t[$i]->label 		= __('Design and Layout','etm');//title on tab
		$t[$i]->right_label	= __('Set defaults for design and layout','etm');//title on tab
		$t[$i]->page_title	= __('Design and Layout','etm');//title on content
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
		
		$temp = array();
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_lang_string',
				'type'	=> 'text',
				'label'	=> __('Text layout','etm'),
				'description' => __('Set the layout for english text use [ENG] and the original text use [ORG]','etm'),
				'default' => '[ORG] ([ENG])',
				'el_properties'=>array('style'=>'width: 200px; margin-left: 120px; margin-bottom: 20px;'),
				'save_option'=>true,
				'load_option'=>true
			);	
			
		$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Menu Placement (do_action)','etm')	
		);
		

		
		
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_pos',
				'type'	=> 'yesno',
				'label'	=> __('Show Language Bar','etm'),
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.desing_menu_pos\');'),
				'description'=>__('Add a tag to your theme where you want the language bar to appear "&lt;?php do_action("etm_languagemenu") ?&gt;".','etm'),
				'default'=>'1',
				'hidegroup'	=> '#hide_desing_menu_group',
				'save_option'=>true,
				'load_option'=>true
			);		
		
		$temp[] = (object)array(
				'id'	=> 'hide_desing_menu_group',
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
		);
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_width',
				'type'	=> 'text',
				'label'	=> __('Width','etm'),
				'description' => __('Set the width of the bar in % or px','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
			
		$temp[] = (object)array(
				'id'	=> 'desing_menu_align',
				'type'	=> 'select',
				'label'	=> __('Select Alignment','etm'),
				'options'=> array(
					'alignleft'=>__('Left','etm'),
					'aligncenter'=>__('Center','etm'),
					'alignright'=>__('Right','etm')
										
				),
				'description'=>__('Select alignment','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
		);	
		
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_info',
				'type'	=> 'select',
				'label'	=> __('Select Display Type','etm'),
				'options'=> array(
					'0'=>__('Show flag and text','etm'),
					'1'=>__('Show only flag','etm'),
					'2'=>__('Show only text','etm')					
				),
				'description'=>__('Select string type','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_flag_size',
				'type'	=> 'select',
				'label'	=> __('Flag size','etm'),
				'options'=> array(
					'0'=>__('Size 1 (16x16)','etm'),
					'1'=>__('Size 2 (24x24)','etm'),
					'2'=>__('Size 3 (32x32)','etm'),
					'3'=>__('Size 4 (48x48)','etm'),				
				),
				'description'=>__('Select flag size','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_type',
				'type'	=> 'select',
				'label'	=> __('Select layout style','etm'),
				'options'=> array(
					'0'=>__('Dropdown menu','etm'),
					'1'=>__('Side by side','etm'),
					'2'=>__('Side by side (Remove Current flag)','etm')					
				),
				'description'=>__('Select formation types','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
			
			
		$temp[] = (object)array(
			'id'=>'hide_desing_menu_group',
			'type'=>'div_end'
		);	
		
			$temp[] = (object)array(
				'type'	=> 'clear',
			);	
			
			
$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Menu Placement Overlay','etm')	
	);	
				
				
	$temp[] = (object)array(
				'id'	=> 'desing_menu_pos_overlay',
				'type'	=> 'yesno',
				'label'	=> __('Show Language Bar as a Lay over','etm'),
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.desing_menu_pos_dashboard\');'),
				'description'=>__('Add a language bar to the main site,','etm'),
				'default'=>'1',
				'hidegroup'	=> '#hide_overlay_desing_menu_group',
				'save_option'=>true,
				'load_option'=>true
			);		
		
		$temp[] = (object)array(
				'id'	=> 'hide_overlay_desing_menu_group',
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
		);
		
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_xpostion_overlay',
				'type'	=> 'text',
				'label'	=> __('X postion','etm'),
				'description' => __('set xpostion extra','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_lockdonw_overlay',
				'type'	=> 'select',
				'label'	=> __('Select Lock Type','etm'),
				'options'=> array(
					'absolute'=>__('Absolute','etm'),
					'fixed'=>__('Fixed','etm')
				),
				'description'=>__('Select lockdown','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
		
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_placement_overlay',
				'type'	=> 'select',
				'label'	=> __('Select Display Type','etm'),
				'options'=> array(
					'topleft'=>__('Top Left','etm'),
					'topright'=>__('Top Right','etm'),
					'sidetopleft'=>__('Side Top Left','etm'),
					'sidetopright'=>__('Side Top Right','etm'),
					'sidebottomleft'=>__('Side Bottom Left','etm'),
					'sidebottomright'=>__('Side Bottom Right','etm'),
					'bottomleft'=>__('Bottom Left','etm'),
					'bottomright'=>__('Bottom Right','etm')	
				),
				'description'=>__('Select postion','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
			
		$temp[] = (object)array(
				'id'	=> 'desing_menu_type_overlay',
				'type'	=> 'select',
				'label'	=> __('Select layout style','etm'),
				'options'=> array(
					'1'=>__('Side by side','etm'),
					'2'=>__('Side by side (Remove Current flag)','etm')						
				),
				'description'=>__('Select formation types','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);
			
			
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_flag_size_overlay',
				'type'	=> 'select',
				'label'	=> __('Flag size','etm'),
				'options'=> array(
					'0'=>__('Size 1 (16x16)','etm'),
					'1'=>__('Size 2 (24x24)','etm'),
					'2'=>__('Size 3 (32x32)','etm'),
					'3'=>__('Size 4 (48x48)','etm'),				
				),
				'description'=>__('Select flag size','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_backgroundalpha_overlay',
				'type'	=> 'text',
				'label'	=> __('Background alpha','etm'),
				'default' => '1.0',
				'description' => __('set background alpha','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
			
		$temp[] = (object)array(
				'id'	=> 'desing_menu_backgroundcolor_overlay',
				'type'	=> 'text',
				'label'	=> __('Background color','etm'),
				'default' => 'ffffff',
				'description' => __('set background color','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
			
			
		$temp[] = (object)array(
				'id'	=> 'desing_menu_boxalpha_overlay',
				'type'	=> 'text',
				'label'	=> __('Boxshadow alpha','etm'),
				'default' => '0.3',
				'description' => __('Set Boxshadow alpha','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
			
		$temp[] = (object)array(
				'id'	=> 'desing_menu_boxcolor_overlay',
				'type'	=> 'text',
				'label'	=> __('Boxshadow color','etm'),
				'default' => '000000',
				'description' => __('Set boxshadow color','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
			
			
		$temp[] = (object)array(
				'id'	=> 'showonlyonpostID',
				'type'	=> 'text',
				'label'	=> __('Show on following IDs','etm'),
				'default' => '',
				'description' => __('f empty it will show on all pages and posts. Enter multiple post id and separate by comma:  2,23,45,89.','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
			
			
			
		
			
		$temp[] = (object)array(
			'id'=>'hide_overlay_desing_menu_group',
			'type'=>'div_end'
		);
			
			
			$temp[] = (object)array(
				'type'	=> 'clear',
			);			
			
	$temp[] = (object)array(
			'type'=>'subtitle',
			'label'=>__('Menu Placement Dashboard','etm')	
	);	
			
			
	$temp[] = (object)array(
				'id'	=> 'desing_menu_pos_dashboard',
				'type'	=> 'yesno',
				'label'	=> __('Show Dashboard Language Bar','etm'),
				'el_properties'	=> array('OnClick'=>'javascript:yesno_panel(this,\'.desing_menu_pos_dashboard\');'),
				'description'=>__('Add a language bar to the dashboard,','etm'),
				'default'=>'1',
				'hidegroup'	=> '#hide_dashboard_desing_menu_group',
				'save_option'=>true,
				'load_option'=>true
			);		
		
		$temp[] = (object)array(
				'id'	=> 'hide_dashboard_desing_menu_group',
				'el_properties'=>array('class'=>'hide_group'),
				'type'=>'div_start'
		);
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_title_dashboard',
				'type'	=> 'text',
				'label'	=> __('Dashboard Metabox header','etm'),
				'description' => __('Dashboard header text','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_width_dashboard',
				'type'	=> 'text',
				'label'	=> __('Width','etm'),
				'description' => __('Set the width of the bar in % or px','etm'),
				'el_properties'=>array('style'=>$unified_css_style),
				'save_option'=>true,
				'load_option'=>true
			);	
			
		$temp[] = (object)array(
				'id'	=> 'desing_menu_align_dashboard',
				'type'	=> 'select',
				'label'	=> __('Select Alignment','etm'),
				'options'=> array(
					'alignleft'=>__('Left','etm'),
					'aligncenter'=>__('Center','etm'),
					'alignright'=>__('Right','etm')
										
				),
				'description'=>__('Select alignment','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
		);	
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_info_dashboard',
				'type'	=> 'select',
				'label'	=> __('Select Display Type','etm'),
				'options'=> array(
					'0'=>__('Show flag and text','etm'),
					'1'=>__('Show only flag','etm'),
					'2'=>__('Show only text','etm')					
				),
				'description'=>__('Select string type','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_flag_size_dashboard',
				'type'	=> 'select',
				'label'	=> __('Flag size','etm'),
				'options'=> array(
					'0'=>__('Size 1 (16x16)','etm'),
					'1'=>__('Size 2 (24x24)','etm'),
					'2'=>__('Size 3 (32x32)','etm'),
					'3'=>__('Size 4 (48x48)','etm'),				
				),
				'description'=>__('Select flag size','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
		
		$temp[] = (object)array(
				'id'	=> 'desing_menu_type_dashboard',
				'type'	=> 'select',
				'label'	=> __('Select layout style','etm'),
				'options'=> array(
					'0'=>__('Dropdown menu','etm'),
					'1'=>__('Side by side','etm'),
					'2'=>__('Side by side (Remove Current flag)','etm')						
				),
				'description'=>__('Select formation types','etm'),
				'el_properties'=>array('class'=>'dropdown2','style'=>$unified_css_style),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);	
			
		$temp[] = (object)array(
			'id'=>'hide_dashboard_desing_menu_group',
			'type'=>'div_end'
		);
			
		$temp[] = (object)array(
				'id'	=> 'desing_menu_css',
				'type'	=> 'text',
				'label' => 'Custom CSS ',
				'description'	=> __('Add custom CSS. Standard CSS location here. ','etm') . '<a href="'.EASY_TRANSLATION_MANAGER_URL.'css/etm-style.css" target="_blank" >'.EASY_TRANSLATION_MANAGER_URL.'css/etm-style.css</a>',
				'el_properties'=>array('style'=>'width: 200px; margin-bottom: 40px; margin-left: 100px;'),
				'save_option'=>true,
				'load_option'=>true
			);	
				
					
			
			
		$temp[] = (object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','etm'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);			
			
			
		$t[$i]->options = $temp;
		
		//------ Languages
		$i++;
		$t[$i] = (object)array();
		$t[$i]->id 			= 'languages-fields'; 
		$t[$i]->label 		= __('Language','etm');//title on tab
		$t[$i]->right_label	= __('Choose your available languages','etm');//title on tab
		$t[$i]->page_title	= __('Language','etm');//title on content
		$t[$i]->theme_option = true;
		$t[$i]->plugin_option = true;
        
		$temp = array();
		$temp[] = (object)array(
			'id'	=> 'languisha_start',
			'type'	=> 'subtitle',
			'label'	=> __('Most Common','etm')
		);        
        
        
		$main_array_default = etm_tools_subval_sort($main_array_default,'default_pos','decs');
		$secoundary_array_default = etm_tools_subval_sort($secoundary_array_default,'english_name','decs');
        
        $count = 0;
        foreach($main_array_default as $key=>$tmpdata){

            $url_icon = etm_tools_create_icons_url($tmpdata['icon'],1);

            if(!empty($url_icon)){
            	if($count == 0){
            		 $url_icon = '<img style="padding-bottom: 10px;margin-top:-3px;padding-right:5px;float:left" src="'.$url_icon.'">';   
            	} else {
            		 $url_icon = '<img style="margin-top:-3px;padding-right:5px;float:left" src="'.$url_icon.'">';   
            	}
                
            }
            $count = 1;
            
            $description = __('Get/post tags','etm'). ' : ' . $tmpdata['code'] . (empty($tmpdata['default_locale']) == false ? ' (' . $tmpdata['default_locale'] . ')' : ''); 
            
			$temp[] = (object)array(
				'id'	=> 'languish_'.$tmpdata['code'],
				'type'	=> 'subtitle',
				'label'	=> $url_icon.'   <div style=float:left>'. $tmpdata['org_name'].' ('.$tmpdata['english_name'].')</div>'
			);
            
            $temp[] = (object)array(
				'id'	=> 'lang_'.$tmpdata['code'],
				'type'	=> 'radio',
				'label'	=> '',
                'description'=>$description,
				'options'=> array('0'=>'<span style="margin-right:20px">'.__('Deactivate','etm').'</span>','1'=>'<span style="margin-right:20px">'.__('Only test ip','etm').'</span>','2'=>'<span style="margin-right:20px">'.__('Activate','etm').'</span>'),
				'el_properties'=>array('class'=>'selectedlangages'),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);
        }
        

		$temp[] = (object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','etm'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);
        
		$temp[] = (object)array(
			'id'	=> 'languisha_middel',
			'type'	=> 'subtitle',
			'label'	=> '<div style="margin-top: 30px;">'.__('Alphabetically Sorted','etm').'</div>'
		);
        
        $count = 0;
        
        foreach($secoundary_array_default as $key=>$tmpdata){

            $url_icon = etm_tools_create_icons_url($tmpdata['icon'],1);

            if(!empty($url_icon)){
            	if($count == 0){
            		 $url_icon = '<img style="padding-bottom: 10px;margin-top:-3px;padding-right:5px;float:left" src="'.$url_icon.'">';   
            	} else {
            		 $url_icon = '<img style="margin-top:-3px;padding-right:5px;float:left" src="'.$url_icon.'">';   
            	}
                
            }
            $count = 1;
            
            
 			$description = __('Get/post tags','etm'). ' : ' . $tmpdata['code'] . (empty($tmpdata['default_locale']) == false ? ' (' . $tmpdata['default_locale'] . ')' : '');
            
             
			$temp[] = (object)array(
				'id'	=> 'languish_'.$tmpdata['code'],
				'type'	=> 'subtitle',
				'label'	=> $url_icon.'   <div style=float:left>'. $tmpdata['org_name'].' ('.$tmpdata['english_name'].')</div>'
			);
            
            $temp[] = (object)array(
				'id'	=> 'lang_'.$tmpdata['code'],
				'type'	=> 'radio',
				'label'	=> '',
                'description'=>$description,
				'options'=> array('0'=>'<span style="margin-right:20px">'.__('Deactivate','etm').'</span>','1'=>'<span style="margin-right:20px">'.__('Only test ip','etm').'</span>','2'=>'<span style="margin-right:20px">'.__('Activate','etm').'</span>'),
				'el_properties'=>array('class'=>'selectedlangages'),
				'default'=>'0',
				'save_option'=>true,
				'load_option'=>true
			);
        }
        
		$temp[] = (object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','etm'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);
        

        
        $t[$i]->options = $temp;	
		
        
        //------------------------- Plugins -------------------
            $i++;
            $t[$i] = (object)array();
            $t[$i]->id 			= 'extra-plugins-listing'; 
            $t[$i]->label 		= __('Support for other plugins','etm');//title on tab
            $t[$i]->right_label	= __('Choose which plugins to support','etm');//title on tab
            $t[$i]->page_title	= __('Choose which plugins to support','etm');//title on content
            $t[$i]->theme_option = true;
            $t[$i]->plugin_option = true;
            $temp = '';
		
			
            $temp[] =(object)array(
				'id'		=> 'seo_plugin_by_yoast',
				'label'		=> __('Use WordPress SEO plugin by Yoast.','etm'),
				'type'		=> 'yesno',
                'description'=>__('If you have this plugin installed, you can enable ETM support for this plugin.','etm'),               
				'save_option'=>true,
				'load_option'=>true
				);
  
            $temp[] = (object)array(
				'type'	=> 'submit',
				'label'	=> __('Save','etm'),
				'class' => 'button-primary',
				'save_option'=>false,
				'load_option'=>false
			);
  
  
            $t[$i]->options = $temp;

        

		return $t;
	}
	
	function create_header(){
        ?>
        <script>
        function setAllToValue(toValue){
           jQuery(document).ready(function($){  
                jQuery('#languages-fields').find('input[class="selectedlangages"]').each(function(index) {
                    
                    if(jQuery(this).val() == toValue){
                        jQuery(this).attr('checked', true);
                    } else {
                        jQuery(this).attr('checked', false);
                    }
                });
           });
        }
		//this would output in the head secction.
        </script>
        <?php
	}

}
?>