<?php
/**
Plugin Name: Easy Translation Manager for WordPress (Downloaded From: 20script.ir)
Plugin URI: http://www.20script.ir
Description: Now you can translate your WordPress powered website easier and faster than ever. Easy Translation Manager lets you translate Pages, Posts,.Post Tags, Post Categories, Custom Post Types, Menus, Plugins and Themes. Your visitors can easily choose their preferred language from a drop down in the sidebar. Or you can automatically set the language based on the browser they are using. The plugin supports Custom Capabilities and is compatible with WordPress Multisite. Support for WordPress SEO by Yoast. 
Version: 2.9.6 rev49048
Author: Rasmus R. Sorensen (RightHere LLC)
Author URI: http://www.20script.ir
**/



$upload_dir = wp_upload_dir();
define("EASY_TRANSLATION_MANAGER_PATH", ABSPATH . 'wp-content/plugins/' . basename(dirname(__FILE__)).'/' ); 
define("EASY_TRANSLATION_MANAGER_URL", trailingslashit(get_option('siteurl')) . 'wp-content/plugins/' . basename(dirname(__FILE__)) . '/' ); 

define("EASY_TRANSLATION_MANAGER_UPLOAD_URL_LANG",trailingslashit(get_option('siteurl')).'wp-content/languages');
define("EASY_TRANSLATION_MANAGER_UPLOAD_PATH_LANG",ABSPATH.'wp-content/languages');
define("EASY_TRANSLATION_MANAGER_UPLOAD_URL",trailingslashit(get_option('siteurl')).'wp-content/languages/etm_manager');
define("EASY_TRANSLATION_MANAGER_UPLOAD_PATH",ABSPATH.'wp-content/languages/etm_manager');

define("ETM_VERSION",'2.9.6'); 
define("ETM_SLUG", plugin_basename( __FILE__ ) );

require_once(EASY_TRANSLATION_MANAGER_PATH.'inc/widgets.php');
require_once(EASY_TRANSLATION_MANAGER_PATH.'inc/tools.php');
require_once(EASY_TRANSLATION_MANAGER_PATH.'inc/install.php'); 

register_activation_hook(__FILE__, 'etm_install'); 
register_deactivation_hook( __FILE__, 'etm_uninstall_capabilities' );


class easy_translation_manager_plugin { 
	var $id = 'etm';
	var $menu_name;
	var $plugin_page; 
	var $selectede_lang;
    var $etm_tools_retrive;
    
	var $selectede_lang_status;
    var $show_lang_status = false;
	var $check_lang = 0;
    var $cachesPostBody = array();
	
	var $tran_terms_data = '';
	var $tran_menu_data = '';
    
    var $first_time = 0;
    var $main_page_first_time = 0;
    var $menu_creation = false;
    var $current_translatede_post_id = 0;
    var $permalink_lockdown = false;
    
	function easy_translation_manager_plugin(){
        $this->etm_tools_retrive = etm_tools_retrive_options();
		add_action('init',  array(&$this, 'init'));
		add_action('widgets_init', array(&$this,"etm_widgets_init" ));
		add_action("plugins_loaded", array(&$this,"plugins_loaded") ,16);
		
		if(empty($this->etm_tools_retrive['deactivate_seach']) and !is_admin()){
			add_filter('posts_join', array(&$this,'search_join'), 10, 2);
			add_filter('posts_where', array(&$this,'search_where'), 10, 2);
			add_filter('posts_groupby', array(&$this,'search_groupby'), 10, 2);
		}
		
		if(is_admin()){
            add_action("admin_menu", array(&$this,"admin_menu") );
			require_once EASY_TRANSLATION_MANAGER_PATH.'options-panel/load.pop.php';
			rh_register_php('options-panel',EASY_TRANSLATION_MANAGER_PATH.'options-panel/class.PluginOptionsPanelModule.php', '2.3.2');		
		}
	}
	
	function search_where($where, &$wp_query)
	{
	    global $wpdb,$current_user;
	    get_currentuserinfo();
	    
		if($wp_query->is_search && !empty($wp_query->query['s'])){
			$this->check_languages();
			
			if(!empty($this->etm_tools_retrive['default_language'])){
				$defualt_lang_tmp = $this->etm_tools_retrive['default_language'];
			} else {
				$defualt_lang_tmp = 'en';
			}

			if(!empty($this->selectede_lang)){
			
				if($defualt_lang_tmp == $this->selectede_lang){
					$tmp_extra = " OR (wp_posts.post_title LIKE '%".$wp_query->query['s']."%') OR (wp_posts.post_content LIKE '%".$wp_query->query['s']."%')";
				} else {
					$tmp_extra = "";
				}
	
				if(!empty($current_user->ID) and $current_user->ID > 0){
					$where = "AND ((({$wpdb->postmeta}.meta_key = 'ect_tran_title_".$this->selectede_lang."' and {$wpdb->postmeta}.meta_value like '%".$wp_query->query['s']."%') OR ({$wpdb->postmeta}.meta_key = 'ect_tran_content_".$this->selectede_lang."' and {$wpdb->postmeta}.meta_value like '%".$wp_query->query['s']."%')".$tmp_extra.")) AND wp_posts.post_type IN ('post', 'page') AND (wp_posts.post_status = 'publish' OR (wp_posts.post_author = ".$current_user->ID." AND wp_posts.post_status = 'private'))";
				} else {
					$where = "AND ((({$wpdb->postmeta}.meta_key = 'ect_tran_title_".$this->selectede_lang."' and {$wpdb->postmeta}.meta_value like '%".$wp_query->query['s']."%') OR ({$wpdb->postmeta}.meta_key = 'ect_tran_content_".$this->selectede_lang."' and {$wpdb->postmeta}.meta_value like '%".$wp_query->query['s']."%')".$tmp_extra.")) AND wp_posts.post_type IN ('post', 'page') AND wp_posts.post_status = 'publish'";	
				}
			}
			
		}
	    return $where;
	}

	function search_join($join, &$wp_query)
	{
	    global $wpdb;
	
	    if($wp_query->is_search && !empty($wp_query->query['s'])) {
			$this->check_languages();
		
			if(!empty($this->selectede_lang)){
	        	$join .= " left join $wpdb->postmeta on $wpdb->posts.ID = $wpdb->postmeta.post_id ";
	        }
	    }
	    return $join;
	}
	
	function search_groupby($groupby, &$wp_query)
	{
	    global $wpdb;
	
	    $mygroupby = "{$wpdb->posts}.ID";
	
	    if(preg_match( "/$mygroupby/", $groupby)) {
	        return $groupby;
	    }
	
	    if(!strlen(trim($groupby))) {
	        return $mygroupby;
	    }
	
	    return $groupby . ", " . $mygroupby;
	}
	
    // show admin menues 
	function admin_menu(){ 
			$this->menu_name = __('ETM Settings','etm');       
            add_menu_page( $this->menu_name, $this->menu_name, 'etm_show_menu', ($this->id.'-start'), array(&$this,'form_options'), EASY_TRANSLATION_MANAGER_URL.'images/etm16.png' );
            
            $this->plugin_page = add_submenu_page(($this->id.'-start'),__("Get Started",'etm'), __("Get Started",'etm'), 'etm_show_menu',($this->id.'-start'), array(&$this,'form_options') );
            
        	do_action(($this->id.'-options-menu'));
        	add_action( 'admin_head-'. $this->plugin_page, array(&$this,'start_head') );
        	
            require_once EASY_TRANSLATION_MANAGER_PATH.'admin/TinyMCE-extra-button.php';
            new etm_tinymce_extra_button();
        	
	}
	
    // start when plugins are loaded
    function plugins_loaded(){
    	global $wpseo_sitemaps,$wpseo_front;

		if ( !session_id() ){
            session_start();
        } 
        
        $check_install = get_option('etm_version');
    	if($check_install < ETM_VERSION){
    		etm_sub_page_installation();
    	} 

        $this->check_languages();
        $this->create_sub_menu();
        $this->controle_menu();
        $this->aktivate_langushes();
        
        add_shortcode('etm_menu', array(&$this,'etm_shortcode_function'));
       
        if(is_admin()){
	       $this->intercept_data();
        }
       
      		
        // SEO controles
    	if(!is_admin() && defined('WPSEO_VERSION') && !empty($this->etm_tools_retrive['seo_plugin_by_yoast'])){
    		remove_action( 'template_redirect', array( $wpseo_sitemaps, 'redirect' ) );
    		require_once(EASY_TRANSLATION_MANAGER_PATH.'inc/yoast-class-sitemaps.php');
    		
    		
    		
    		if(WPSEO_VERSION < '1.2.8.7'){
    			require_once(EASY_TRANSLATION_MANAGER_PATH.'inc/yoast-class-frontend.php');	
    		} else if(WPSEO_VERSION < '1.5.2.5'){
    			require_once(EASY_TRANSLATION_MANAGER_PATH.'inc/yoast-class-frontend1524.php');
    		} else {
	    		require_once(EASY_TRANSLATION_MANAGER_PATH.'inc/yoast-class-frontend1287.php');
    		}
    		
    		 
    	} 
    }

    // check languages
	function check_languages(){
        $selectede_lang = '';
        $lang_tag_array = '';
        
        if(!empty($this->etm_tools_retrive['GP_name'])){
			$lang_tag_array = $this->etm_tools_retrive['GP_name'];
        }

        if(!empty($lang_tag_array)){
            $lang_tag_array = explode('|',$lang_tag_array);
            
            foreach ($lang_tag_array as $tmp_tag){
                if(isset($_GET[$tmp_tag]) && !empty($_GET[$tmp_tag])){
                	if(is_admin()){
                		$_SESSION['etm_lang_wpadmin'] = $_GET[$tmp_tag];
                	} else {
                		$_SESSION['etm_lang'] = $_GET[$tmp_tag];
                	}
                    
                    break;
                } else if(isset($_POST[$tmp_tag]) && !empty($_POST[$tmp_tag])){
                	if(is_admin()){
                		$_SESSION['etm_lang_wpadmin'] = $_POST[$tmp_tag];
                	} else {
                    	$_SESSION['etm_lang'] = $_POST[$tmp_tag];
                    }
                    break;
                }
            }
        
                   
            if(!empty($_SESSION['etm_lang']) && !is_admin()){
                $selectede_lang = $_SESSION['etm_lang'];
            } else if(!empty($_SESSION['etm_lang_wpadmin']) && is_admin()){
                $selectede_lang = $_SESSION['etm_lang_wpadmin'];
            } else {
            	$browser_languash = $this->etm_tools_retrive['browser_languash'];

            	if(!empty($browser_languash)){
            		 $lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
            		 if(is_admin()){
            		 	$_SESSION['etm_lang_wpadmin'] = $lang;
            		 } else {
            		 	$_SESSION['etm_lang'] = $lang;
            		 }
            		 
            		 $selectede_lang = $lang;
            	} else {
            	
            		if(is_admin()){
            			if(!empty($this->etm_tools_retrive['default_language_wp_etm'])){
	            			$default_languashwp =  $this->etm_tools_retrive['default_language_wp_etm'];
            			}
            			if(!empty($default_languashwp)){
            				$_SESSION['etm_lang_wpadmin'] = $default_languashwp;
            		 		$selectede_lang = $default_languashwp;
            			}	 
            		} else {
            			if(!empty($this->etm_tools_retrive['default_language'])){
	            			$default_languash =  $this->etm_tools_retrive['default_language']; 
            			}
            			         		 
            			if(!empty($default_languash)){
            				$_SESSION['etm_lang'] = $default_languash;
            		 		$selectede_lang = $default_languash;
            			}
            		}           		 
            	}
            }
        }
        $this->selectede_lang = $selectede_lang;
        
        if(!empty($this->etm_tools_retrive['lang_'. $this->selectede_lang])){
        	$this->selectede_lang_status =  $this->etm_tools_retrive['lang_'. $this->selectede_lang];
        }

		$test_ip_array = array();
		if(!empty($this->etm_tools_retrive['test_ip'])){
    		$test_ip_array = str_replace (" ", "", $this->etm_tools_retrive['test_ip']);
    		$test_ip_array = explode('|',$test_ip_array);
		}

		if(!empty($this->selectede_lang_status) && ($this->selectede_lang_status == 2 || ( $this->selectede_lang_status == 1 && !empty($test_ip_array) && in_array($_SERVER['REMOTE_ADDR'], $test_ip_array, true)) )){
			$this->show_lang_status = true;
		} else {
            if(is_admin()){
            	$default_languashwp = '';
            	if(!empty($this->etm_tools_retrive['default_language_wp_etm'])){
            		$default_languashwp =  $this->etm_tools_retrive['default_language_wp_etm'];
            	}
           	 	if(!empty($default_languashwp)){
            		$_SESSION['etm_lang_wpadmin'] = $default_languashwp;
            		$this->selectede_lang = $default_languashwp;
            		$this->show_lang_status = true;
            	} else {
            		$this->show_lang_status = false;
            	}
            } else {
            	$default_languash =  '';
            	if(!empty($this->etm_tools_retrive['default_language'])){
            		$default_languash =  $this->etm_tools_retrive['default_language'];
            	}

           	 	if(!empty($default_languash)){
            		$_SESSION['etm_lang'] = $default_languash;
            		$this->selectede_lang = $default_languash;
            		$this->show_lang_status = true;
            	} else {
            		$this->show_lang_status = false;
            	}
            }
		}
		
		$this->tran_terms_data = get_option('ect_tran_terms_'.$this->selectede_lang);
		$this->tran_menu_data = get_option('ect_tran_menu_'.$this->selectede_lang);	
	}
    
    // create sub menu pages in admin
	function create_sub_menu(){
        require EASY_TRANSLATION_MANAGER_PATH.'admin/class.admin_translation.php';
        new admin_etm_admin_translation($this->id);	
        
        require EASY_TRANSLATION_MANAGER_PATH.'admin/class.admin_importexportpo.php';
        new admin_etm_importexportpo($this->id);		
        	
        
		if(is_admin()){
			$settings = array(
				'id'					=> $this->id.'-opt',
				'plugin_id'				=> $this->id,
				'menu_id'				=> $this->id.'-opt',
				'options_panel_version'	=> '2.3.2',
				'capability'			=> 'etm_options',
				'capability_license'	=> 'etm_license',
				'options_varname'		=> 'etm_options',
				'options_parameters'	=> array(),
				'page_title'			=> __('Options','etm'),
				'menu_text'				=> __('Options','etm'),
				'option_menu_parent'	=> ($this->id.'-start'),
				'notification'			=> (object)array(
					'plugin_version'=>  ETM_VERSION,
					'plugin_code' 	=> 'ETM',
					'message'		=> __('Easy Translation Manager update %s is available!','wlb').' <a href="%s">'.__('Please update now','wlb')
				),
				'registration' 		=> true,
				'theme'					=> false,
                'fileuploader'			=> true,
				'extracss'				=> 'extracss-etm',
				'import_export'  		=> false,
				'import_export_options' => false,
				'pluginslug'	=> ETM_SLUG,
				'api_url' 		=> "http://plugins.righthere.com"
				);	
			
			
			

				
			
			
			
			
			do_action('rh-php-commons');			 	
			//require_once EASY_TRANSLATION_MANAGER_PATH.'options-panel/class.PluginOptionsPanelModule.php';		 	
			new PluginOptionsPanelModule($settings);				
			
            require_once EASY_TRANSLATION_MANAGER_PATH.'admin/option.panel.php';
            new etm_options($this->id);	
		}
	}
	
    // create flag list
    function controle_menu(){
    	if(is_admin() && !empty($this->etm_tools_retrive['desing_menu_pos_dashboard']) and $this->etm_tools_retrive['desing_menu_pos_dashboard'] == 1){
    	    add_action('wp_dashboard_setup', array(&$this,'add_dashboard_widgets') );
    	}
    	
    	if(!empty($this->etm_tools_retrive['desing_menu_pos']) and $this->etm_tools_retrive['desing_menu_pos'] == 1){
    		add_action('etm_languagemenu', array(&$this,'create_menu') ); 
    	}
    	
    	if(!is_admin() && !empty($this->etm_tools_retrive['desing_menu_pos_overlay']) and $this->etm_tools_retrive['desing_menu_pos_overlay'] == 1){
    		add_action('wp_footer', array(&$this,'etm_overlay_menu'), 100);    
    	}
    }
    
	function HexToRGB($hex) {
		$hex = ereg_replace("#", "", $hex);
		$color = array();
 
		if(strlen($hex) == 3) {
			$color['r'] = hexdec(substr($hex, 0, 1) . $r);
			$color['g'] = hexdec(substr($hex, 1, 1) . $g);
			$color['b'] = hexdec(substr($hex, 2, 1) . $b);
		} else if(strlen($hex) == 6) {
			$color['r'] = hexdec(substr($hex, 0, 2));
			$color['g'] = hexdec(substr($hex, 2, 2));
			$color['b'] = hexdec(substr($hex, 4, 2));
		}
 
		return $color;
	}
    
	function etm_overlay_menu() {
		if(!empty($this->etm_tools_retrive['desing_menu_placement_overlay'])){
			$desing_menu_placement_overlay = $this->etm_tools_retrive['desing_menu_placement_overlay'];
		} else {
			$desing_menu_placement_overlay = 'topright';
		}
		
		if(!empty($this->etm_tools_retrive['desing_menu_type_overlay'])){
			$desing_menu_type_overlay = $this->etm_tools_retrive['desing_menu_type_overlay'];
		} else {
			$desing_menu_type_overlay = '1';
		}
		
		
		if(!empty($this->etm_tools_retrive['desing_menu_xpostion_overlay'])){
			$desing_menu_xpostion_overlay = $this->etm_tools_retrive['desing_menu_xpostion_overlay'];
		} else {
			$desing_menu_xpostion_overlay = 0;
		}

		if($desing_menu_placement_overlay == 'topright' || $desing_menu_placement_overlay == 'topcenter' || $desing_menu_placement_overlay == 'topleft'){
		echo '<style type="text/css">
				body {
					margin-top: -28px;
					padding-bottom: 28px;
				}
				body.admin-bar #wphead {
					padding-top: 0;
				}
				body.admin-bar #footer {
					padding-bottom: 28px;
				}
				#wpadminbar {
					top: auto !important;
					bottom: 0;
				}
				#wpadminbar .quicklinks .menupop ul {
					bottom: 28px;
				}
			</style>';
		}
		
		$css = '';
		
		if(!empty($this->etm_tools_retrive['desing_menu_flag_size_overlay'])){
			$desing_menu_flag_size_overlay = $this->etm_tools_retrive['desing_menu_flag_size_overlay'];
		} else {
			$desing_menu_flag_size_overlay = 0;
		}
		
		
		
		
		
		
		if($desing_menu_placement_overlay == 'topleft' || $desing_menu_placement_overlay == 'bottomleft'){
			$css = 'margin-left:'.$desing_menu_xpostion_overlay.'px;';
		} else if($desing_menu_placement_overlay == 'topright' || $desing_menu_placement_overlay == 'bottomright'){
			$css = 'margin-right:'.$desing_menu_xpostion_overlay.'px;';
		} else if($desing_menu_placement_overlay == 'sidetopleft' || $desing_menu_placement_overlay == 'sidetopright'){
			$css = 'top:'.$desing_menu_xpostion_overlay.'px;';
		} else if($desing_menu_placement_overlay == 'sidebottomleft' || $desing_menu_placement_overlay == 'sidebottomright'){
			$css = 'bottom:'.$desing_menu_xpostion_overlay.'px;';
		}
		
		if(!empty($this->etm_tools_retrive['desing_menu_lockdonw_overlay'])){
			$css .= 'position:'.$this->etm_tools_retrive['desing_menu_lockdonw_overlay'] . ';';
		} else {
			$css .= 'position: absolute;';
		}
		
		if(!empty($this->etm_tools_retrive['desing_menu_backgroundalpha_overlay'])){
			$desing_menu_backgroundalpha_overlay = $this->etm_tools_retrive['desing_menu_backgroundalpha_overlay'];
		} else {
			$desing_menu_backgroundalpha_overlay = 1.0;
		}
		
		if(!empty($this->etm_tools_retrive['desing_menu_backgroundcolor_overlay'])){
			$desing_menu_backgroundcolor_overlay = $this->etm_tools_retrive['desing_menu_backgroundcolor_overlay'];
		} else {
			$desing_menu_backgroundcolor_overlay = '#ffffff';
		}
		
		if(!empty($desing_menu_backgroundcolor_overlay) and !empty($desing_menu_backgroundalpha_overlay)){
			$temp = $this->HexToRGB($desing_menu_backgroundcolor_overlay);
			$css .= 'background: rgba('.$temp['r'].','.$temp['g'].','.$temp['b'].','. $desing_menu_backgroundalpha_overlay.') !important;';
			
		}
		
		if($desing_menu_placement_overlay == 'sidebottomleft' || $desing_menu_placement_overlay == 'sidebottomright' || $desing_menu_placement_overlay == 'sidetopleft' || $desing_menu_placement_overlay == 'sidetopright'){

			if($desing_menu_flag_size_overlay == 0){
				$css .= 'width:28px;line-height:1px;'; 
			} else if($desing_menu_flag_size_overlay == 1){
				$css .= 'width:26px;line-height:1px;'; 
			} else if($desing_menu_flag_size_overlay == 2){
				$css .= 'width:36px;line-height:1px;'; 
			} else if($desing_menu_flag_size_overlay == 3){
				$css .= 'width:52px;line-height:1px;'; 
			}
		}
		
		
		if(!empty($this->etm_tools_retrive['desing_menu_boxalpha_overlay'])){
			$desing_menu_boxalpha_overlay = $this->etm_tools_retrive['desing_menu_boxalpha_overlay'];
		} else {
			$desing_menu_boxalpha_overlay = 0;
		}
		
		if(!empty($this->etm_tools_retrive['desing_menu_boxcolor_overlay'])){
			$desing_menu_boxcolor_overlay = $this->etm_tools_retrive['desing_menu_boxcolor_overlay'];
		} else {
			$desing_menu_boxcolor_overlay = '#000000';
		}
		
		if(!empty($desing_menu_boxcolor_overlay) and !empty($desing_menu_boxalpha_overlay)){
			$temp = $this->HexToRGB($desing_menu_boxcolor_overlay);
			$css .= 'box-shadow : 0 0 5px 1px rgba('.$temp['r'].','.$temp['g'].','.$temp['b'].','. $desing_menu_boxalpha_overlay.') !important;';
		}
		
		global $post;
		$postid = get_the_ID();
		
		$showonlyonpostIDarray = '';
		
		if(!empty($this->etm_tools_retrive['showonlyonpostID'])){
			$showonlyonpostID = $this->etm_tools_retrive['showonlyonpostID'];
			$showonlyonpostIDarray = explode(',', $showonlyonpostID);
		}
		
		
		
		if(empty($showonlyonpostIDarray) or (!empty($showonlyonpostIDarray) and in_array($postid, $showonlyonpostIDarray))){
			echo '<div style="'.$css.'" class="etmoverlay_all etmoverlay_'.$desing_menu_placement_overlay.'">';
			$this->create_menu(' ',' ',1,$desing_menu_flag_size_overlay,$desing_menu_type_overlay);
			echo '</div>';
			echo '<link rel="stylesheet" type="text/css" href="'.EASY_TRANSLATION_MANAGER_URL.'css/etm-style2.css"></link>';
		}
	}
    
	function change_url($string) {
		if(!empty($string) && !empty($this->etm_tools_retrive['use_permalink']) && empty($main_page_first_time)){
			$splitaray = array();
			$main_page_first_time = 1;
			$checkup_string =  array('pagename','name','category_name','tag','attachment','error');
			
			$splitaray = explode('&', $string);
			foreach($splitaray as $_key => $_data){
				$splitaray[$_key] = explode('=', $_data);
					
				if(in_array($splitaray[$_key][0], $checkup_string)){
					return $this->checkpermalink($splitaray[$_key][0],$splitaray[$_key][1]);
					break;
				}
			}
		}
		return $string;
	}
	
	function checkpermalink($tmp_name,$tmp_string){
		$return_str = '';
        $id_lang = array();
	
		if($tmp_name == 'pagename' || $tmp_name == 'name' || $tmp_name == 'attachment' || ($tmp_name == 'error' && $tmp_string == '404')){
			global $wpdb;
			$get_array = explode('%2F', $tmp_string);
			
			if($tmp_name == 'attachment' || $tmp_name == 'error'){
				$tmp_name = 'pagename';
				
				$url = substr($_SERVER["REQUEST_URI"],1);
				if(!empty($url) && $url != '/'){
					$url_pice = explode("?", $url,2);
	           		if(substr( $url_pice[0], -1) == '/')
	                	$url_pice[0] = substr( $url_pice[0],0, -1); 
	     
	            	$get_array = $url_pice;
				}
			}
			
			$post_id = array();
			if(!empty($get_array)){
				$post_id = $wpdb->get_results("SELECT post_id,meta_key FROM {$wpdb->prefix}postmeta WHERE meta_key like '%ect_tran_permalink_%' and meta_value in ('".implode("/','", $get_array) ."/')");
			}
        	        	   	
        	if(!empty($post_id)){  
        		$post_id = $post_id[0];
            	$lang = substr($post_id->meta_key, -2);    
            	if(strlen($lang)>0 and strlen($lang) < 4){
            		$id_lang[0] = $post_id->post_id;
            		$id_lang[1] = $lang;
            		$type_tmp = get_post_type( $post_id->post_id );
					$this->current_translatede_post_id = $post_id->post_id;

					if($type_tmp == 'page'){
						$return_str = 'page_id='.$id_lang[0];
					} else {
						$return_str = 'p='.$id_lang[0];
					}
            	}
        	}
		} else if($tmp_name == 'tag'){
			echo 'test';
            $tran_terms_list = '';
            $id_lang = '';
            $tran_terms_list = get_option('ect_tran_terms_checkuplist_post_tag');
            
            if(!empty($tran_terms_list)){
                foreach($tran_terms_list as $key => $tmp_data){
                    if($tmp_string == $tmp_data){
                        $id_lang = explode("_", $key);
						$test = get_tag($id_lang[0]);
						
						if(!empty($test->slug2)){
							$return_str = 'tag='.$test->slug2;
						}

                        break;
                    }
                }  
            }
                      
		
		} else if($tmp_name == 'category_name'){
            $tran_terms_list = '';
            $tran_terms_list = get_option('ect_tran_terms_checkuplist_category');
            
            if(!empty($tran_terms_list)){
                foreach($tran_terms_list as $key => $tmp_data){
                    if($tmp_data == $tmp_string){
                        $id_lang = explode("_", $key);
						$return_str = 'cat='.$id_lang[0];
                        break;
                    }
                }  
            }
		}
		
        if(!empty($id_lang)){
        	if(is_admin()){
        		$_SESSION['etm_lang_wpadmin'] = $id_lang[1];
        	} else {
        		$_SESSION['etm_lang'] = $id_lang[1];
        	}
        
            $this->selectede_lang = $id_lang[1];
            $this->check_languages(); 
        }		
		
		
		if(empty($return_str)){
			$return_str = $tmp_name.'='.$tmp_string;
		}
		
		return $return_str;
		
	}


    // activate lang
    function aktivate_langushes(){
    	global $wpdb;
    	   	
    	$tmp_change_wp_admin = false;
    	
    	if(!empty($this->etm_tools_retrive['change_wp_admin'])){
    		$tmp_change_wp_admin = $this->etm_tools_retrive['change_wp_admin'];
    	}
    
		if($this->show_lang_status && ($tmp_change_wp_admin || !is_admin())){
            
            if(!is_admin()){
               add_filter('the_posts',array(&$this,'the_posts'),1,1);
          		add_filter('get_pages',array(&$this,'get_pages'),0,1);  
                add_filter('page_link',array(&$this,'page_link'),10,2);  
		        add_filter('post_link',array(&$this,'page_link'),10,2);
    			add_filter('get_the_terms',array(&$this,'the_terms'),1,1);
                add_filter('get_terms', array(&$this,'get_terms'), 1, 1);
                add_filter('get_term', array(&$this,'get_term'), 1, 1);           
                add_filter('wp_get_nav_menu_items', array(&$this,'remove_menu_args'), 0, 4);
                add_filter('get_post_metadata', array(&$this,'get_metadata'), true, 4);
                add_filter('wp_get_attachment_image_attributes',array(&$this,'post_attachment'),0,2);
               
                add_filter('query_string', array(&$this,'change_url'), 1);
            }
             
			$check_if_plugins = get_option('etm_options_plugin_tran');	
			if($check_if_plugins == 'true'){
       		    $sqllang = "SELECT option_value FROM  {$wpdb->prefix}options WHERE option_name = 'etm_mo_files'";
    			$etm_mo_files = $wpdb->get_var($sqllang);
				$etm_mo_files = unserialize($etm_mo_files);		
			} else {
       		    $sqllang = "SELECT option_value FROM  {$wpdb->base_prefix}options WHERE option_name = 'etm_mo_files'";
    			$etm_mo_files = $wpdb->get_var($sqllang);
				$etm_mo_files = unserialize($etm_mo_files);	
			}
			
			if(!empty($etm_mo_files)){
           		foreach($etm_mo_files as $tmp_data){
                	$this->setup_lang($tmp_data);
           		}
       		}
            
       		if(!empty($tmp_change_wp_admin) && $tmp_change_wp_admin){
       			add_filter('locale', array(&$this,'wp_admin_locale') );       		
       		}
			
			add_filter('the_content',array(&$this,'post_plugin_body'),0,2);
			add_filter('the_title',array(&$this,'post_plugin_title'),0,2);   
			
			
			
			/*
            add_filter('get_the_excerpt',array(&$this,'post_the_excerpt'),0,2);
			add_filter('single_tag_title',array(&$this,'single_term_title'),1,1);			
			add_filter('single_cat_title',array(&$this,'single_term_title'),1,1);			
			add_filter('wp_categories',array(&$this,'the_category'),1,1);
			*/


		} 
    }
    
       
   // --------------------------------- CREATE MENU -------------------------------- 
  function create_menu($width = '',$align = '',$desing_menu_info = '', $desing_menu_flag_size = '', $desing_menu_type = '',$shortcodestatus= false){
        global $post,$wpdb;
        $this->menu_creation = true;
        $fade_tran_array = '';        
        if((is_single() || is_page()) && !is_admin() && $this->etm_tools_retrive['fade_none_translation_menu']){
            $fade_trans = $wpdb->get_results("SELECT meta_key FROM {$wpdb->prefix}postmeta WHERE (meta_key like '%ect_tran_content_%' or meta_key like '%ect_tran_title_%') and post_id=".$post->ID);
            if(!empty($fade_trans)){  
                foreach($fade_trans as $fade_tran ){
                    $lang = substr($fade_tran->meta_key, -2);    
                    if(strlen($lang)>0 and strlen($lang) < 4){
                        $fade_tran_array[$lang] = true;
                    }  
                }
            }
        }
        
    	$tmp_lang = etm_tools_retrive_aktiv_languages('',false);
    
    	if(!empty($this->etm_tools_retrive['default_language'])){
    		$tmp_lang[$this->etm_tools_retrive['default_language']] = 2;
    	}
    
    	$languashed = etm_tools_retrive_languages_data($tmp_lang,true);
    	$languashed = etm_tools_subval_sort($languashed,'org_name','desc');
    	$langed_string = ''; 
    	$array_size_number = array('-2px','2px','7px','14px');


		if($shortcodestatus){
        	if($desing_menu_info == ''){$desing_menu_info = 0;}
        	if($desing_menu_flag_size == ''){$desing_menu_flag_size = 0;} 
        	if($desing_menu_type == ''){$desing_menu_type = 0;} 
		} else {
        	if(empty($width) && !empty($this->etm_tools_retrive['desing_menu_width'])){
        		$width = $this->etm_tools_retrive['desing_menu_width'];
        	}
        
        	if(empty($align) && !empty($this->etm_tools_retrive['desing_menu_align'])){
        		$align = $this->etm_tools_retrive['desing_menu_align'];
        	}      
        
        	if($desing_menu_info == ''){
          		$desing_menu_info = $this->etm_tools_retrive['desing_menu_info'];
        	}
        	if($desing_menu_flag_size == ''){
        		$desing_menu_flag_size = $this->etm_tools_retrive['desing_menu_flag_size'];
        	} 
        	if($desing_menu_type == ''){
        		$desing_menu_type = $this->etm_tools_retrive['desing_menu_type'];
        	} 
		}
		
        	if(!empty($this->etm_tools_retrive['desing_menu_lang_string'])){
        		$desing_menu_lang_string = $this->etm_tools_retrive['desing_menu_lang_string'];
        	} else {
	        	$desing_menu_lang_string = '[ORG] ([ENG])';
        	}
		

        
		$tmp_rtl = etm_languages_flags($this->selectede_lang);
		
		if($this->show_lang_status && !empty($tmp_rtl['rtl']) && $tmp_rtl['rtl']){
			$tmp_rtl = 'rtl';
		} else {
			$tmp_rtl = 'ltr';
		}
        
        $lang_tag_string = $this->etm_tools_retrive['GP_name'];

        if(!empty($lang_tag_string)){
            $lang_tag_array = explode('|',$lang_tag_string);
        }
        
		if($desing_menu_type == 0){
			$this->check_lang += 1;
		}
		
		$generaterandom = rand();
        
        if($this->check_lang == 1 ){
        	if(empty($desing_menu_type)){
        		$langed_string .= '<script type="text/javascript" src="'.EASY_TRANSLATION_MANAGER_URL.'js/jquery.dd.js"></script>';
        		if(!empty($this->etm_tools_retrive['desing_menu_css'])){
        			$langed_string .= '<link rel="stylesheet" type="text/css" href="'.$this->etm_tools_retrive['desing_menu_css'].'"></link>';
        		} else {
        			$langed_string .= '<link rel="stylesheet" type="text/css" href="'.EASY_TRANSLATION_MANAGER_URL.'css/etm-style.css"></link>';
        		}
        	}
		}
    	if(count($languashed) > 0){ 
			if(!empty($desing_menu_type) and ($desing_menu_type == 1 or $desing_menu_type == 2)){
			
				$langed_string .= '<span ';
			
       			if(!empty($width)){
        			$langed_string .= ' style="width:'.$width.'" ';
        		}
        		
       			if(!empty($align)){
        			$langed_string .= ' class="'.$align.'" ';
        		}
        		
        		$langed_string .= ' >';
        		
			} else { 
			
				$dropdow_width_size_array = array('40px','50px','63px','85px');
				
				if (preg_match("/Firefox/", $_SERVER['HTTP_USER_AGENT'])) {
					$dropdow_width_size_array = array('65px','75px','85px','100px');
				} 
				
				if($desing_menu_info == 1){
					$dropdow_width_size = $dropdow_width_size_array[$desing_menu_flag_size];
				} else if($desing_menu_info == 2){
					$dropdow_width_size = '208px';
					$desing_menu_flag_size = 0;
				} else {
					$dropdow_width_size = '258px';
				}
				
       			if(!empty($width)){
        			$dropdow_width_size = $width;
        		}



				$langed_string .= '<select onChange="window.location = this.value" name="easy-translation-manger_menu'.$this->check_lang.'_'.$generaterandom.'" id="easy-translation-manger_menu'.$this->check_lang.'_'.$generaterandom.'" style="width:'.$dropdow_width_size.';" >';
			}
			
		        if(empty($this->current_translatede_post_id) && !empty($post)){
			        $this->current_translatede_post_id = $post->ID;
		        }
			
			
			
			
			
			

            if(!empty($this->current_translatede_post_id) && $this->current_translatede_post_id > 0 && $this->etm_tools_retrive['use_permalink'] && !is_admin()){
                $tran_permalink = $wpdb->get_results("SELECT meta_value,meta_key FROM {$wpdb->prefix}postmeta WHERE post_id=".$this->current_translatede_post_id." and meta_key like '%ect_tran_permalink_%'");
        		$tran_permalink_array = array();	
        		foreach ($tran_permalink as $tmp_perma){
        			$tran_permalink_array[substr($tmp_perma->meta_key, -2)] = $tmp_perma->meta_value;
        		}
        		unset($tran_permalink);
    	     }
    	     
    	     $this->permalink_lockdown = true;
            
            foreach($languashed as $langedtemp){	
            
            
            	$tmp_string_text = str_replace('[ORG]',$langedtemp['org_name'],$desing_menu_lang_string);
            	$tmp_string_text = str_replace('[ENG]',$langedtemp['english_name'],$tmp_string_text);
            
            	$var_tmp = '';
      			$arr_params = '';
   		        $perma_params = '';
                
                if(!empty($tran_permalink_array) && !empty($tran_permalink_array[$langedtemp['code']])){
                	$perma_params = $tran_permalink_array[$langedtemp['code']];
                } else {
	                $perma_params = '';
                }
                
                
                

                if(!empty($perma_params)  &&  $perma_params != '/'){
			         $var_tmp = trailingslashit(get_option('siteurl')) . $perma_params;
                } else {
                	if(!empty($lang_tag_array)){
	          			foreach ($lang_tag_array as $tmp_tag){
	          				$arr_params[$tmp_tag] = $langedtemp['code'];
	          			}
                	}

    				$var_tmp = add_query_arg( $arr_params ); 
    				if(!empty($this->current_translatede_post_id) && $this->current_translatede_post_id > 0 && $this->etm_tools_retrive['use_permalink'] && !is_admin()){
    					$var_tmppieces = '';
    					$var_tmppieces = explode("?", $var_tmp);
                        if(!empty($var_tmppieces[1])){
                            $var_tmp = get_permalink($this->current_translatede_post_id).'?'.$var_tmppieces[1];
                        }
    				}
                }
                

				if(!empty($desing_menu_type) and ($desing_menu_type == 1 or $desing_menu_type == 2)){
					$tmp_image = '';
					$tmp_text = '';
					
					if($desing_menu_type == 2 && $langedtemp['code'] == $this->selectede_lang){
						
					} else if((is_single() || is_page()) && !is_admin() && $this->etm_tools_retrive['fade_none_translation_menu'] && !$fade_tran_array[$langedtemp['code']] && $this->etm_tools_retrive['default_language'] != $langedtemp['code']){
					   $tmp_image = '<span style="float: left;"><img style="filter: alpha(opacity=50);opacity: 0.5;" src="'.etm_tools_create_icons_url($langedtemp['icon'],$desing_menu_flag_size).'" title="'.$tmp_string_text . '"></span>';
					   $tmp_text = '<span style="float: left;color: #999;margin-left: 5px;margin-top: '.$array_size_number[$desing_menu_flag_size].';">'.$tmp_string_text . '</span>';
                    } else {
					   $tmp_image = '<span style="float: left;"><img src="'.etm_tools_create_icons_url($langedtemp['icon'],$desing_menu_flag_size).'" title="'.$tmp_string_text . '"></span>';
					   $tmp_text = '<span style="float: left;margin-left: 5px;margin-top: '.$array_size_number[$desing_menu_flag_size].';">'.$tmp_string_text . '</span>';  
					}
					if($desing_menu_info == 1){
						$margin_right_spacing = '1px';
					} else if($desing_menu_info == 2){	
						$margin_right_spacing = '10px';
					} else {
						$margin_right_spacing = '20px';
					}
					
					
					if($desing_menu_type == 2 && $langedtemp['code'] == $this->selectede_lang){
						
					} else if((is_single() || is_page()) && !is_admin() && $this->etm_tools_retrive['fade_none_translation_menu'] && !$fade_tran_array[$langedtemp['code']] && $this->etm_tools_retrive['default_language'] != $langedtemp['code']){
					   $langed_string .= '<span style="margin-right: '.$margin_right_spacing.';float: left;">';
                    } else {
					   $langed_string .= '<span style="margin-right: '.$margin_right_spacing.';float: left;"><a href="'.$var_tmp.'">';
                    }
					
					if($desing_menu_info == 1){
						$langed_string .= $tmp_image;
					} else if($desing_menu_info == 2){
						$langed_string .= $tmp_text;
					} else {
						$langed_string .= $tmp_image;
						$langed_string .= $tmp_text;	
					}
				
                    if($desing_menu_type == 2 && $langedtemp['code'] == $this->selectede_lang){
						
					} else if((is_single() || is_page()) && !is_admin() && $this->etm_tools_retrive['fade_none_translation_menu'] && !$fade_tran_array[$langedtemp['code']] && $this->etm_tools_retrive['default_language'] != $langedtemp['code']){
                        $langed_string .= '</span>';
                    } else {
                        $langed_string .= '</a></span>';
                    }
				} else { 
					
					$langed_string .= '<option ';
					$langed_string .= 'value="'.$var_tmp.'" ';
					
					if($desing_menu_info != 2){
						$langed_string .= 'title="'.etm_tools_create_icons_url($langedtemp['icon'],$desing_menu_flag_size).'" ';
					}
					if( $langedtemp['code'] == $this->selectede_lang ){
						$langed_string .= 'selected="selected"';
					}

                    if((is_single() || is_page()) && !is_admin() && $this->etm_tools_retrive['fade_none_translation_menu'] && !$fade_tran_array[$langedtemp['code']] && $this->etm_tools_retrive['default_language'] != $langedtemp['code']){
                            $langed_string .= ' disabled="disabled" ';         
                    }
                    
					$langed_string .= '>';
					if($desing_menu_info != 1){
						
						$langed_string .= $tmp_string_text;
					} else {
						$langed_string .= '	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;  &ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;	&ensp;'.$tmp_string_text;
					
					}
					$langed_string .= '</option>';
					
				}
        	}
        	
			if(($desing_menu_type == 1 or $desing_menu_type == 2)){ 
				$langed_string .= '</span><div style="clear:both"></div>';
			} else {
				$langed_string .= '</select><div style="clear:both"></div>';
				$langed_string .= '<script>
					jQuery(document).ready(function($){
					try {
						var oHandler = jQuery("#easy-translation-manger_menu'.$this->check_lang.'_'.$generaterandom.'").msDropDown({mainCSS:\'etm'.$desing_menu_flag_size.' '.$align.' ' . $tmp_rtl . '\'}).data("etm");
						jQuery("#ver").html(jQuery.msDropDown.version);';
				if(!empty($align)){
        			$langed_string .= 'jQuery("#easy-translation-manger_menu'.$this->check_lang.'_'.$generaterandom.'").addClass(\''.$align.'\');';
        		}	
				$langed_string .= '} catch(e) {
						alert("Error: "+e.message);
					}
				});
			</script>';
			}
    	}
    	
    	 $this->permalink_lockdown = false;
    	
    	if($shortcodestatus){
    		$this->menu_creation = false;
    		return ($langed_string != '' ? $langed_string : '' );
    	} else {
    		echo ($langed_string != '' ? $langed_string : '' );
        	$this->menu_creation = false;
        	return '';
    	}
    }
 
    //-----------------------------------------------------------------------------------------
    //-----------------------------------------------------------------------------------------
    // new version of the system --------------------------------------------------------------
    
   function get_pages($maindata) { 
        global $wpdb;

        foreach($maindata as $key => $tmp_data){
            $translatede_body = '';
            $translatede_excerpt = '';
            $translatede_title = '';
            
            if($tmp_data->ID > 0){
                $translatede_body = get_post_meta($tmp_data->ID, 'ect_tran_content_'.$this->selectede_lang, true);
          		$translatede_excerpt = get_post_meta($tmp_data->ID, 'etm_content_excerpts_'.$this->selectede_lang, true);
		        $translatede_title = get_post_meta($tmp_data->ID, 'ect_tran_title_'.$this->selectede_lang, true);

        		if(!empty($translatede_body) ){
        			$maindata[$key]->post_content = $translatede_body;
        		}
                
        		if(!empty($translatede_excerpt) ){
        			$maindata[$key]->post_excerpt = $translatede_excerpt;
        		}
                
        		if(!empty($translatede_title) ){
        			$maindata[$key]->post_title = $translatede_title;
        		}
                
                if($this->etm_tools_retrive['default_language'] != $this->selectede_lang || (!empty($this->etm_tools_retrive['hide_elements_default']) && $this->etm_tools_retrive['hide_elements_default'])){
                    if(!is_admin()){
                        if(!empty($this->etm_tools_retrive['hide_elements_pages']) && $this->etm_tools_retrive['hide_elements_pages'] && $tmp_data->post_type == "page" && empty($translatede_title) && empty($translatede_body) && empty($translatede_excerpt)){
                            unset($maindata[$key]);    
                        }   
                    }    
                }
    		}
        }
            
    	return $maindata;	
    }  
    
    // translate the post and remove post
    function the_posts($maindata) { 
        global $wpdb;

        if(empty($maindata) && $this->current_translatede_post_id > 0 && $this->etm_tools_retrive['use_permalink']){
        	$maindata = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}posts WHERE ID=".$this->current_translatede_post_id." ORDER BY post_date DESC");
        }
        
        foreach($maindata as $key => $tmp_data){
            $translatede_body = '';
            $translatede_excerpt = '';
            $translatede_title = '';
            
            if($tmp_data->ID > 0){
                $translatede_body = get_post_meta($tmp_data->ID, 'ect_tran_content_'.$this->selectede_lang, true);
          		$translatede_excerpt = get_post_meta($tmp_data->ID, 'etm_content_excerpts_'.$this->selectede_lang, true);
		        $translatede_title = get_post_meta($tmp_data->ID, 'ect_tran_title_'.$this->selectede_lang, true);


        		if(!empty($translatede_body) ){
        			$maindata[$key]->post_content = $translatede_body;
        		}
                
        		if(!empty($translatede_excerpt) ){
        			$maindata[$key]->post_excerpt = $translatede_excerpt;
        		}
                
        		if(!empty($translatede_title) ){
        			$maindata[$key]->post_title = $translatede_title;
        		}
                
                if($this->etm_tools_retrive['default_language'] != $this->selectede_lang || $this->etm_tools_retrive['hide_elements_default']){
                    if(!is_admin()){
                        if(!empty($this->etm_tools_retrive['hide_elements_posts']) && $this->etm_tools_retrive['hide_elements_posts'] && $tmp_data->post_type == "post" && empty($translatede_title) && empty($translatede_body) && empty($translatede_excerpt)){
                            unset($maindata[$key]);   
                        }
                        if(!empty($this->etm_tools_retrive['hide_elements_pages']) && $this->etm_tools_retrive['hide_elements_pages'] && $tmp_data->post_type == "page" && empty($translatede_title) && empty($translatede_body) && empty($translatede_excerpt)){
                            unset($maindata[$key]);    
                        }   
                    }    
                }
    		}
        }
            
    	return $maindata;	
    }
    
    // translate tag categories multi   
 	function the_terms($before){
 		global $wpdb;
        if(!empty($before)){
	 		foreach($before as $key => $data){
	 			$translatede_tmp = (object) array();
	 			if(!empty($this->tran_terms_data[$data->term_id])){
		 			$translatede_tmp = $this->tran_terms_data[$data->term_id];
	 			}
	 		
				
	
	            if(!empty($translatede_tmp->slug) && $this->etm_tools_retrive['use_permalink']){
	            	$before[$key]->slug2 = $before[$key]->slug;
	               $before[$key]->slug = $translatede_tmp->slug; 
	            }
	            
	            if(!empty($translatede_tmp->description)){
	               $before[$key]->description = $translatede_tmp->description; 
	            }           
	            
	 			if(!empty($translatede_tmp->name)){
	 				$before[$key]->name = $translatede_tmp->name;
	 			} else {
	                if(!is_admin() && ($this->etm_tools_retrive['default_language'] != $this->selectede_lang || $this->etm_tools_retrive['hide_elements_default'])){
	                    if($this->etm_tools_retrive['hide_elements_categories'] && $before[$key]->taxonomy == 'category'){
	                        unset($before[$key]);  
	                    } else if($this->etm_tools_retrive['hide_elements_tags'] && $before[$key]->taxonomy == 'post_tag'){
	                        unset($before[$key]);  
	                    }
	                } 
	    	   }  	 
	 		}
        }
        
 		return $before;

 	}  
    
    // translate tag categories single
    function get_term( $term, $taxonomies = null, $args = null )
    {
 		global $wpdb;
        
		$translatede_tmp = '';
		
		if(!empty($this->tran_terms_data) && !empty( $this->tran_terms_data[$term->term_id])){
			$translatede_tmp = $this->tran_terms_data[$term->term_id];
		}
		
        if(!empty($translatede_tmp->slug) && $this->etm_tools_retrive['use_permalink']){
           $term->slug2 = $term->slug;
           $term->slug = $translatede_tmp->slug; 
        }
        
        if(!empty($translatede_tmp->description)){
           $term->description = $translatede_tmp->description; 
        }           
        
		if(!empty($translatede_tmp->name)){
			$term->name  = $translatede_tmp->name;
		} else {
            if(!is_admin() && ($this->etm_tools_retrive['default_language'] != $this->selectede_lang || $this->etm_tools_retrive['hide_elements_default'])){
                if($this->etm_tools_retrive['hide_elements_categories'] && $term->taxonomy == 'category'){
                    return '';  
                } else if($this->etm_tools_retrive['hide_elements_tags'] && $term->taxonomy == 'post_tag'){
                     return '';   
                }
            } 
		}  
        
 		return $term;
    }
 
    // translate tag categories multi
    function get_terms( $terms)
    {
 		global $wpdb;
        if(!empty($terms)){
	 		foreach($terms as $key => $data){
	 			$translatede_tmp = (object) array();
	 			if(!empty($this->tran_terms_data[$data->term_id])){
		 			$translatede_tmp = $this->tran_terms_data[$data->term_id];
	 			}
				
				
	            if(!empty($translatede_tmp->slug) && $this->etm_tools_retrive['use_permalink']){
	               $terms[$key]->slug2 = $terms[$key]->slug;
	                $terms[$key]->slug = $translatede_tmp->slug; 
	            }
	            
	            if(!empty($translatede_tmp->description)){
	               $terms[$key]->description = $translatede_tmp->description; 
	            }           
	
	 			if(!empty($translatede_tmp->name)){
	 				$terms[$key]->name  = $translatede_tmp->name;
	 			} else {
	                if(!is_admin() && ($this->etm_tools_retrive['default_language'] != $this->selectede_lang || $this->etm_tools_retrive['hide_elements_default'])){
	                    if($this->etm_tools_retrive['hide_elements_categories'] && $terms[$key]->taxonomy == 'category'){
	                        unset($terms[$key]);  
	                    } else if($this->etm_tools_retrive['hide_elements_tags'] && $terms[$key]->taxonomy == 'post_tag'){
	                        unset($terms[$key]);  
	                    }
	                } 
	 			}  
	 		}
 		}
 		return $terms;
    }
 
    // menu translation
    function remove_menu_args($data=null,$data2=null,$data3=null,$data4=null){   
        global $wpdb;
        
        foreach($data as $key => $tmp_data){
    		$translatede_title = '';
            
            if($tmp_data->post_type == 'nav_menu_item'){
            
            	if(!empty($tmp_data->ID) && !empty($this->tran_menu_data) && !empty($this->tran_menu_data[$tmp_data->ID])){
	           		$translatede_title = $this->tran_menu_data[$tmp_data->ID];	
            	}

                if(!empty($translatede_title->attr_title)){
                    $data[$key]->attr_title = $translatede_title->attr_title;  
                }
                if(!empty($translatede_title->title)){
                    $data[$key]->title = $translatede_title->title;  
                }
                if(!empty($translatede_title->url)){
                    $data[$key]->url = $translatede_title->url;  
                }    
                
                if(!empty($translatede_title->description)){
                    $data[$key]->description = $translatede_title->description;  
                }    
                
                if(!empty($translatede_title->title)){
		            $translatede_title = $translatede_title->title;   
                }
                
                
                if(($tmp_data->object == 'category' || $tmp_data->object == 'post_tag' ) && empty($translatede_title)){
	                
        			$translatede_title = '';
        			if(!empty($this->tran_terms_data) && !empty($this->tran_terms_data[$tmp_data->object_id])){
        				$translatede_title = $this->tran_terms_data[$tmp_data->object_id];
        			}

                    if(!empty($translatede_title->name)){
                        $data[$key]->title = $translatede_title->name;  
                    }
                    if(!empty($translatede_title->name)){
	                  $translatede_title = $translatede_title->name;  
                    }
                    
                    
                }
                
                
                
                
                
    		} else {
    			$translatede_title = get_post_meta($tmp_data->ID, 'ect_tran_title_'.$this->selectede_lang, true);
    		}
            
            if(!empty($this->etm_tools_retrive['use_permalink']) && $this->etm_tools_retrive['use_permalink']){				
            	$translatede_permalink = '';
                if($tmp_data->object == 'page' || $tmp_data->type == 'post'){
                    $translatede_permalink = get_post_meta($tmp_data->object_id, 'ect_tran_permalink_'.$this->selectede_lang, true); 
                }
                
                if(!empty($translatede_permalink) && $translatede_permalink !='/'){
                    $data[$key]->url = '/'.$translatede_permalink;
                }
            }
            
            if($this->etm_tools_retrive['default_language'] != $this->selectede_lang || $this->etm_tools_retrive['hide_elements_default']){
                if(!is_admin() && $this->etm_tools_retrive['hide_elements_menus']){
                    if(empty($translatede_title)){
                        unset($data[$key]);  
                    }     
                } 
            }
        }
        return $data;    
    }    
 
 // Get meta data custom fields
    function get_metadata($metadata, $object_id = null, $meta_key = null, $single = null){
        if(!is_admin() && $meta_key != '_edit_lock' && $meta_key != '_edit_last' && substr($meta_key,0,4) != 'ect_' && substr($meta_key,0,4) != 'etm_' && substr($meta_key,0,7) != '_yoast_' && substr($meta_key,-3,1) != '_'){
           
            $translations_body = get_post_meta($object_id, $meta_key.'_'.$this->selectede_lang, true); 
        
            if(!empty($translations_body)){
                return $translations_body;  
            }
        }
        return $metadata;
    }
 
 // load mo themes plugins mo files
    function setup_lang($lang_domain){
        if(!empty($lang_domain->url) && !empty($lang_domain->path)){
    		$mofileurl = $this->selectede_lang.'.mo' ; 
    		if (!file_exists($lang_domain->url.$mofileurl)) {
    			@chmod($lang_domain->path.$mofile, 755);
    			load_textdomain( $lang_domain->domain, $lang_domain->path.$mofileurl );
    		}  
        }
	}
 
 // Change wp admin languages
    function wp_admin_locale( $locale ) {
    	$tmp = etm_languages_flags($this->selectede_lang);
    		
    	$return_lang = '';
    	if($this->show_lang_status && !empty($tmp['default_locale'])){
    			$return_lang = $tmp['default_locale'];
    	} else {
    		$return_lang =WPLANG;
    	}
    	return $return_lang;
    }
 
 // post attachement for images attached images
	function post_attachment($content,$attachment = null){
        if($attachment->ID > 0){
            
            $translatede_image_alt = get_post_meta($attachment->ID, 'etm_attachment_image_alt_'.$this->selectede_lang, true);
            $translatede_title = get_post_meta($attachment->ID, 'ect_tran_title_'.$this->selectede_lang, true);
            
            if(!empty($translatede_image_alt)){
                $content['alt'] = $translatede_image_alt;
            }
            
            if(!empty($translatede_title)){
                $content['title'] = $translatede_title;
            }
        }
        return $content;
	}  
    

    function page_link($maindata,$id = '',$test2 = ''){
    	if(!empty($id) && !empty($this->etm_tools_retrive['use_permalink']) && !is_admin()){
    		$id_tmp = 0;
    		if(is_numeric($id)){
	    		$id_tmp = $id;
    		} else {
	    		$id_tmp = $id->ID;
    		}
    		
    		
    	
    		$translatede_permalink = get_post_meta($id_tmp, 'ect_tran_permalink_'.$this->selectede_lang, true);
    		
    		
    		
    		if(!empty($translatede_permalink) && $translatede_permalink != '/'){
    			$maindata = trailingslashit(get_option('siteurl')) . $translatede_permalink;
    		}
    	}
    
    	return $maindata;
    }    
    
 /*

    function single_term_title($before = ''){
		global $wp_query,$wpdb;
 		
 		$tag = $wp_query->get_queried_object();
		$translatede_tmp = $this->tran_terms_data[$tag->term_id];




 		if(!empty($translatede_tmp)){

 			return $translatede_tmp;
 		} else {
            if(!is_admin() && ($this->etm_tools_retrive['default_language'] != $this->selectede_lang || $this->etm_tools_retrive['hide_elements_default'])){
                if($this->etm_tools_retrive['hide_elements_categories'] && $tag->taxonomy == 'category'){
                    return ''; 
                } else if($this->etm_tools_retrive['hide_elements_tags'] && $tag->taxonomy == 'post_tag'){
                    return '';  
                }
            } 
			return $before;
 		}
  	}
  
*/
	function post_plugin_title($title,$id = ''){
	
		global $wpdb;
		
		$type = get_post_type($id);
		$translatede_title = '';
		
		if($type == 'nav_menu_item'){
			if(!empty($this->tran_menu_data) && !empty($this->tran_menu_data[$id]) && !empty($this->tran_menu_data[$id]->title))			{
				$translatede_title = $this->tran_menu_data[$id]->title;	
				if(!empty($translatede_title)){
					$translatede_title = str_replace('\"','"',$translatede_title);
					$translatede_title = str_replace("\'","'",$translatede_title);	
				
					preg_match('/\[loginout (login|logout)=(\'|\")(.*)(\'|\") (login|logout)=(\'|\")(.*)(\'|\")/',$translatede_title,$testreturn);

					if(!empty($testreturn) && count($testreturn) > 4){
						if ( is_user_logged_in()){
							if(!empty($testreturn[1]) && $testreturn[1] == 'logout'){
								$translatede_title = $testreturn[3];
							} else if(!empty($testreturn[5]) && $testreturn[5] == 'logout'){
								$translatede_title = $testreturn[7];
							}
						} else {
							if(!empty($testreturn[1]) && $testreturn[1] == 'login'){
								$translatede_title = $testreturn[3];
							} else if(!empty($testreturn[5]) && $testreturn[5] == 'login'){
								$translatede_title = $testreturn[7];
							}	
						}	
					}
				}
			}
		} else {
			$translatede_title = get_post_meta($id, 'ect_tran_title_'.$this->selectede_lang, true);
		}

		if(!empty($translatede_title) && $id > 0){
			return $translatede_title;
		} else {
			return $title;
		}
	
	}
    /*
    function post_the_excerpt($content){
		global $post,$wpdb;
		
		$translatede_excerpt = get_post_meta($post->ID, 'etm_content_excerpts_'.$this->selectede_lang, true);
		
		if(!empty($translatede_excerpt) && $post->ID > 0){
			return $translatede_excerpt;
		} else {
			return $content;
		}  
    } */
    
	function post_plugin_body($content){
		global $post,$wpdb;
		

		if($post->post_type == 'events'){
	             return $content;
		}
        
        if($post->ID > 0 ){
            $translatede_body = get_post_meta($post->ID, 'ect_tran_content_'.$this->selectede_lang, true);
		}
        
		if(!empty($translatede_body) ){
			return $translatede_body;
		} else {
			return $content;
		}
        return $content;
	}
    
   
    
    //------------------------------------ extra functions -----------------------------------
    // public functions
    
    // extra function to get active langauges
    function activ_lang_array(){
    	$tmp_lang = etm_tools_retrive_aktiv_languages('',false);
    
    	if(!empty($this->etm_tools_retrive['default_language'])){
    		$tmp_lang[$this->etm_tools_retrive['default_language']] = 2;
    	}
    
    	$languashed = etm_tools_retrive_languages_data($tmp_lang,true);
    
        $return_array = '';
    
        foreach($languashed as $tmp){
            $return_array[$tmp['code']] = $tmp['english_name'] . ' ('.$tmp['org_name'].')';    
        }
        
        return $return_array;
    }  
    
    // extra function to get content
    function get_the_content($more_link_text, $stripteaser){
        global $post, $more, $page, $pages, $multipage, $preview;
	
	        if ( null === $more_link_text )
	                $more_link_text = __( '(more...)' );
	
	        $output = '';
	        $hasTeaser = false;
	
	        // If post password required and it doesn't match the cookie.
	        if ( post_password_required($post) ) {
	                $output = get_the_password_form();
	                return $output;
	        }
	
	        if ( $page > count($pages) ) // if the requested page doesn't exist
	                $page = count($pages); // give them the highest numbered page that DOES exist
	
	        $content = $pages[$page-1];
	        if ( preg_match('/<!--more(.*?)?-->/', $content, $matches) ) {
	                $content = explode($matches[0], $content, 2);
	                if ( !empty($matches[1]) && !empty($more_link_text) )
	                        $more_link_text = strip_tags(wp_kses_no_null(trim($matches[1])));
	
	                $hasTeaser = true;
	        } else {
	                $content = array($content);
	        }
	        if ( (false !== strpos($post->post_content, '<!--noteaser-->') && ((!$multipage) || ($page==1))) )
	                $stripteaser = true;
	        $teaser = $content[0];
	        if ( $more && $stripteaser && $hasTeaser )
	                $teaser = '';
                      
	        $output .= $teaser;
	        if ( count($content) > 1 ) {
	                if ( $more ) {
	                        $output .= '<span id="more-' . $post->ID . '"></span>' . $content[1];
	                } else {
	                        if ( ! empty($more_link_text) )
	                                $output .= apply_filters( 'the_content_more_link', ' <a href="' . get_permalink() . "#more-{$post->ID}\" class=\"more-link\">$more_link_text</a>", $more_link_text );
	                        $output = force_balance_tags($output);
	                }
	
	        }
	        if ( $preview ) // preview fix for javascript bug with foreign languages
	                $output = preg_replace_callback('/\%u([0-9A-F]{4})/', '_convert_urlencoded_to_entities', $output);
	
            $output = apply_filters('the_content',$output);
	        return $output;
    }
    
    
 // --------------------------------- GET STARTED -----------------------------	
 // Get startede page
    
    function start_head(){
        ?>
        <link rel="stylesheet" type="text/css" href="<?php echo EASY_TRANSLATION_MANAGER_URL; ?>css/main.css" />
        <link rel="stylesheet" type="text/css" href="<?php echo EASY_TRANSLATION_MANAGER_URL; ?>css/get_started.css" />
        <?php
    } 
        
    function form_options(){
    	if(true){
			include_once(EASY_TRANSLATION_MANAGER_PATH.'admin/get_started.php');
    	} else {
            echo '<strong>Important information for translators</strong>: Dont translate anything inside [  ].<br>';
            echo 'This is "shortcodes" used by the system to render specific content. If it is translated it will break the system.';
    	}
    }
    
 
 // ---------------------------------- INIT ---------------------------------------
 // Dirrection of the language
 
 	function intercept_data(){
		if(isset($_REQUEST['etm_data'])){
		
			if($_REQUEST['etm_fn']=='load_multi_data'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.load_multi_data.php');
			}
			
			if($_REQUEST['etm_fn']=='load_groups'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.load_groups.php');
			}
			
			if($_REQUEST['etm_fn']=='mo_read_save_string'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.mo_read_save_string.php');
			}
			
			if($_REQUEST['etm_fn']=='mo_reloadIndex'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.mo_reloadIndex.php');
			}
			
			if($_REQUEST['etm_fn']=='mo_generator'){
				include_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.mo_generator.php');
			}
			
			if($_REQUEST['etm_fn']=='page_post_read_save_string'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.page_post_read_save_string.php');
			}
			
			if($_REQUEST['etm_fn']=='terms_read_save_string'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.terms_read_save_string.php');
			}
			
			if($_REQUEST['etm_fn']=='menu_read_save_string'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.menu_read_save_string.php');
			}
			
			if($_REQUEST['etm_fn']=='meta_read_save_string'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frame.meta_read_save_string.php');
			}
			
			if($_REQUEST['etm_fn']=='load_table_data'){
				require_once(EASY_TRANSLATION_MANAGER_PATH.'frames/frames.load_table_data.php');
			}
		}
	}

    function init(){
		global $wp_locale;
		
		
		wp_enqueue_script('jquery');
		
    	if(is_admin()){
    		wp_register_style( 'extracss-etm', EASY_TRANSLATION_MANAGER_URL.'css/etm-extra.css', array(),'1.0.0');
        }

		$tmp = etm_languages_flags($this->selectede_lang);
		if($this->show_lang_status && !empty($tmp['rtl']) && $tmp['rtl']){
			if(is_admin()){
				wp_register_style( 'wp-admincss', trailingslashit(get_option('siteurl')).'wp-admin/css/wp-admin-rtl.min.css', array(),'1.0.0');
				wp_enqueue_style('wp-admincss');
			} else {
				$tmp_file = 'rtl.css';
				if(!empty($this->etm_tools_retrive['rtl_front_page_css'])){
	    			$tmp_file = $this->etm_tools_retrive['rtl_front_page_css'];
	    		}
	    		
	    		$tmp_path = get_template_directory().'/';
	    		$tmp_url = get_template_directory_uri().'/';
	    		
	    		$tmp_path_file = $tmp_path.$tmp_file;
	    		
				if (file_exists($tmp_path_file) && $tmp_file != 'rtl.css') {
					wp_register_style( 'rtl', $tmp_url.$tmp_file, array(),'1.0.0');
					wp_enqueue_style('rtl');
				}
			}

			$wp_locale->text_direction = 'rtl';
		} else {
			$wp_locale->text_direction = 'ltr';
		}
    }
    
    // ---------------------------------- ADD SHORTCODE ---------------------------------------
	function etm_shortcode_function($atts) {

		if(empty($atts['class'])){
			$atts['class'] = '';
		}
		if(empty($atts['aligment'])){
			$atts['aligment'] = '';
		}
		if(empty($atts['width'])){
			$atts['width'] = '';
		}
		if(empty($atts['display'])){
			$atts['display'] = 0;
		}
		if(empty($atts['flag'])){
			$atts['flag'] = 0;
		}
		if(empty($atts['layout'])){
			$atts['layout'] = 0;
		}
		if(empty($atts['style'])){
			$atts['style'] = '';
		}
	
		$content =  '<div class="'.$atts['class'].' ' .$atts['aligment'].'" ';
			if(!empty($atts['style'])){
				$content .= 'style="'.$atts['style'].'" ';
			}
		$content .= '>';
		$content .= $this->create_menu($atts['width'],$atts['aligment'],$atts['display'],$atts['flag'],$atts['layout'],true);
		
		$content .= '</div>';	
		
		return $content;
	} 
    
    
    
    // ---------------------------------- ADD WIDGET ---------------------------------------
 
 	function etm_widgets_init(){
 		register_widget( 'etm_langaush_widget' );
 	}    
    
    // ---------------------------------- ADD dashboard ---------------------------------------    
    
	function dashboard_widget_function() {
		$this->create_menu($this->etm_tools_retrive['desing_menu_width_dashboard'],$this->etm_tools_retrive['desing_menu_align_dashboard'],$this->etm_tools_retrive['desing_menu_info_dashboard'],$this->etm_tools_retrive['desing_menu_flag_size_dashboard'],$this->etm_tools_retrive['desing_menu_type_dashboard']);
		
	} 

	function add_dashboard_widgets() {
		if(empty($this->etm_tools_retrive['desing_menu_title_dashboard'])){
			$this->etm_tools_retrive['desing_menu_title_dashboard'] = 'Select language';
		
		}
		wp_add_dashboard_widget('etm_dashboard_widget', __($this->etm_tools_retrive['desing_menu_title_dashboard'],'etm'), array(&$this,'dashboard_widget_function'));	
	
		global $wp_meta_boxes;
	
		$normal_dashboard = $wp_meta_boxes['dashboard']['normal']['core'];
	
		$example_widget_backup = array('etm_dashboard_widget' => $normal_dashboard['etm_dashboard_widget']);
		unset($normal_dashboard['etm_dashboard_widget']);
		$sorted_dashboard = array_merge($example_widget_backup, $normal_dashboard);
		$wp_meta_boxes['dashboard']['normal']['core'] = $sorted_dashboard;
	}  
}
$easy_translation_manager_plugin = new easy_translation_manager_plugin();
?>